//* 01/10/05	in wr_cf_data changed wr_cf_io16s to wr_cf_io16
//* 04/01/05	added WAIT input at RG4..Grounded CSEL at CF connector
//* 04/15/05	fixed arp response bap_write changed +8 to +16 to pick up 12 bytes of source/dest mac addr length and 4 bytes of data length
//* 04/15/05	added code to buffer_alloc_event_handler to handle possible new reclaimed FID
//* 04/15/05	added WEP capability
//*	04/15/05	changed fidrid buffer size to 256
//************************************************************************************************
//* THIS VERSION --
//* * NO WEP
//* * PARSES FOR COR ADDR
//* * DOES NOT CREATE CIS DUMP FOR USE WITHIN MPLAB AS DESCRIBED IN THE BOOK
//* * IP ADDRESS = 192.168.1.151
//* * SSID = AIRDROP_NETWORK
//************************************************************************************************

#include <pic18.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>
//#include <math.h>
#include "airdrop_P_hitech_sensor.h"


// PIC18LF6722 FUSES
__CONFIG(1,FCMDIS & IESODIS & HS);
__CONFIG(2,BORDIS & PWRTDIS & WDTDIS);
__CONFIG(3,LPT1DIS & MCLREN);
__CONFIG(4,DEBUGDIS & LVPDIS & STVREN & XINSTDIS);
__CONFIG(5,UNPROTECT);
__CONFIG(6,WRTEN);

#define esc 0x1B

const float C1 = -4.0;
const float C2 = 0.0405;
const float C3 = -0.0000028;
const float T1 = 0.01;
const float T2 = 0.00008;

#if (ad802_11Header)
	#define TxControl				0x0C	// Transmit frame structure TxControl field (use 802.11 Frame Structure header fields, generate a
														// TxExc event if frame transmit problem, don't generate a TxExc event if the transmit is successful)
	#define txdestaddr_offset		30		// Bytes from beginning of transmit frame structure to destination Ethernet MAC address
	#define txbssid_offset			18		// Bytes from beginning of transmit frame structure to BSS ID
	#define datalength_offset		44		// Bytes from beginning of transmit frame structure to to Length field
	#define rxsourceaddr_offset		30		// For receive only
	#define rxdestaddr_offset		18		// Bytes from beginning of receive frame structure to destination Ethernet MAC address
	#define rxbssid_offset			24		// Bytes from beginning of receive frame structure to BSS ID
#else
	#define TxControl				0x04	// Transmit frame structure TxControl field (use 802.3 Frame Structure header fields, generate a
													// TxExc event if frame transmit problem, don't generate a TxExc event if the transmit is successful)
	#define txbssid_offset			18		// Bytes from beginning of transmit frame structure to BSS ID

	#define txdestaddr_offset		46
	#define txsourceaddr_offset		52
	#define rxdestaddr_offset		46
	#define rxsourceaddr_offset		52
	#define datalength_offset		58		// Bytes from beginning of transmit frame structure to 802.3 byte-swapped format length field
#endif
#define rxdatalength_offset			44		// use the length from the 802.11 part of the header, as it
#define rxdata_offset				60
#define txdata_offset			    60

#define framestructure_size			46			// Number of bytes in Compact Flash data Frame Structure (including the unused 802.11 header bytes, but not the 802.3 header)
#define ethheader_size				14			// Number of bytes in the Compact Flash data Frame Structure 802.3 header
#define mac_length			     	6
#define snap_length					3
#define eth_mtu_buffer_size			1500
#define txframe_buffer_size			eth_mtu_buffer_size+framestructure_size+ethheader_size	


#define fidrid_buffer_size	256
unsigned int fidrid_buffer[fidrid_buffer_size];

#define rxframeheader_buffer_size	framestructure_size+ethheader_size				
char rxframeheader_buffer[rxframeheader_buffer_size];

char tple_data[1024];

char comframe_buffer[60];
unsigned int TxFID_buffers[3];
char free_TxFIDs;
unsigned int RxFID,i;
char tempstring[];
char aux_data[2],macaddrc[6],bssidc[6],remotemacaddrc[6];  
unsigned int macaddri[3],ipaddri[2],bssidi[3],remotemacaddri[3],remoteipaddri[2];
unsigned int *addr,cmd_data,cor_addr;
char byte_read,data_H,data_L,cntrc,byteout;
unsigned int txlen,rxlen,chksum16,hdrlen,tcplen,tcpdatalen_in,cntri;
unsigned int tcpdatalen_out,ISN,portaddr,ip_packet_len;
unsigned long hdr_chksum,my_seqnum,client_seqnum,incoming_ack,expected_ack;
char error,temp_chksum, humi_chksum;
unsigned int humi_val, temp_val,rh_lin, rh_true;
 

const char ssid[] = "AIRDROP";
//const char wepkey[] = {0x46,0xFA,0xF1,0x7C,0x83,0x99,0xC7,0x6B,0x85,0x81,0xEE,0x48,0x8A,0x00};
const char wepkey[] = {0x80,0x1E,0x6F,0x12,0xBB,0x5C,0xCA,0x53,0x50,0xAC,0xA4,0x4B,0x0A,0x00};

//******************************************************************
//*	IP ADDRESS DEFINITION
//*   This is the Ethernet Module IP address.
//*   You may change this to any valid address.
//******************************************************************
char ipaddrc[4] = { 192,168,1,151};
char remoteipaddrc[4] = {192,168,1,2};
//******************************************************************
//*	Function Declarations
//******************************************************************
void init_USART1(void);
unsigned char CharInQueue(void);
void putch(unsigned char c);
int recvchar(void);
int sendchar(int data);
char airdrop_cfg(unsigned int cmd);
void wr_cf_data(char bapnum,char* buffer,unsigned int count);
void rd_cis(void);
void init_nic(void);
void wr_cf_addr(unsigned int addr);
void wr_cf_reg(unsigned int data, unsigned int reg_addr);
char rd_cf_reg(unsigned int reg_addr);
void wr_cf_io16(unsigned int data16,unsigned int addr);
void wr_cf_io16s(unsigned int data16,unsigned int addr);
unsigned int rd_cf_io16(unsigned int addr);
unsigned int rd_cf_io16s(unsigned int addr);
char send_command(unsigned int cmd, unsigned int parm0);
char rid_write(unsigned int fidrid, unsigned int* buffer, unsigned int count);
char bap_write(unsigned int fidrid,unsigned int offset,char* buffer, unsigned int count);
void rid_string_write(unsigned int fidrid, unsigned int ridlen, unsigned int* buffer);
char fid_read(unsigned int fid);
char rid_read(unsigned int rid);
void create_comframestructure(unsigned int len);
char allocate_buffer(unsigned int bufferlen);
char allocate_xmit_buffers(void);
unsigned int get_free_TxFID(void);
unsigned int swapbytes(unsigned int val);
void do_event_housekeeping(void);
void setipaddrs(void);
void cksum(void);
char echo_packet(void);
//void Delay_ms(unsigned int mticks);
char arp(void);
char arp_request(void);
void icmp(void);
void udp(void);
void tcp(void);
void send_tcp_packet(void);
void init_udp();
char send_udp(void);
char send_udp_discard(void);
void application_code(void);
//void assemble_ack(void);
void delay_ms(char delay);
char airdrop_max_datalen(unsigned int max_len);
void get_octet(void);
char sht_write_byte(char value);
char sht_read_byte(char ack);
void sht_xmit_start(void);
void sht_connectionreset(void);
char sht_softreset(void);
char sht_read_statusreg(char *p_value, char *p_checksum);
char sht_write_statusreg(char *p_value);
char sht_measure(unsigned int *p_value, char *p_checksum, char mode);
void cls(void);

char hours, mins, secs;
char chr_count,bytein;
char eeaddr;
// ip_address_3.ip_address_2.ip_address_1.ip_address_0
unsigned int parameters[11];
#define local_ipaddr				0x00
#define	local_ipaddr3				0x00
#define	local_ipaddr2				0x01
#define	local_ipaddr1				0x02
#define	local_ipaddr0				0x03
#define host_ipaddr					0x04
#define	host_ipaddr3				0x04
#define	host_ipaddr2				0x05
#define	host_ipaddr1				0x06
#define	host_ipaddr0				0x07
#define loopsecs					0x08
unsigned long udpaddrs[2];
#define local_udpaddr				0x00
#define remote_udpaddr				0x01

char ipentry[3];
#define chr_3				0x00
#define chr_2				0x01
#define chr_1				0x02
//******************************************************************
//*	SENSOR I/O Definitions
//******************************************************************
typedef union 
{ unsigned int i;
  float f;
} value;

enum {TEMP,HUMI};

#define TO_SENSOR	TRISA = 0b11111001
#define FROM_SENSOR TRISA = 0b11111011
#define DATA_IN		RA1
#define	DATA   		LATA1 
#define	SCK   		LATA2

#define noACK 0
#define ACK   1
                            //adr  command  r/w
#define STATUS_REG_W 0x06   //000   0011    0
#define STATUS_REG_R 0x07   //000   0011    1
#define MEASURE_TEMP 0x03   //000   0001    1
#define MEASURE_HUMI 0x05   //000   0010    1
#define SENSORRESET  0x1E   //000   1111    0

//******************************************************************
//*	Flags
//******************************************************************
char flags;
#define synflag 	0x01  
#define	finflag		0x02  
#define entryflag 	0x04
#define arpflag		0x08
#define bsynflag   	flags & synflag
#define bfinflag	flags & finflag
#define bentryflag	flags & entryflag
#define barpflag	flags & arpflag

#define clr_synflag flags &= ~synflag
#define set_synflag flags |= synflag
#define clr_finflag flags &= ~finflag
#define set_finflag flags |= finflag
#define clr_entryflag flags &= ~entryflag
#define set_entryflag flags |= entryflag
#define clr_arpflag flags &= ~arpflag
#define set_arpflag flags |= arpflag

#define cisflag	0x04
#define bcisflag	flags & cisflag
#define setf_cis	flags |= cisflag
#define clrf_cis	flags &= ~cisflag
//******************************************************************
//*	Macros
//******************************************************************
#define bitset(var, bitno) ((var) |= 1 << (bitno))
#define bitclr(var, bitno) ((var) &= ~(1 << (bitno)))
#define make8(var,offset)	((unsigned int)var >> (offset * 8)) & 0x00FF
#define	make16(varhigh,varlow)	(((unsigned int)varhigh & 0xFF)* 0x100) + ((unsigned int)varlow & 0x00FF)
#define make32(var1,var2,var3,var4) \
		((unsigned long)var1<<24)+((unsigned long)var2<<16)+ \
		((unsigned long)var3<<8)+((unsigned long)var4)		
#define make32i(var1,var2) ((unsigned long)var1<<16)+((unsigned long)var2)

//******************************************************************
//*	CIS
//******************************************************************
#define io_en_mask	0x01
#define rd_code_tuple	rd_cf_reg
#define rd_link_tuple	rd_cf_reg
#define rd_tuple_data	rd_cf_reg
#define rd_cor_data	    rd_cf_reg
#define wr_cor_data		wr_cf_reg
//******************************************************************
//*	PORT Definitions
//******************************************************************
#define AOUT	 LATA
#define BOPEN	 PORTB
#define COPEN    PORTC
#define data_in  PORTD
#define data_out LATD
#define PCTL     LATF
#define addr_hi	 LATG
#define addr_lo	 LATE
//#define PCOMM	 LATJ
//******************************************************************
//*	CF I/O Definitions
//******************************************************************
#define OE			0x01
#define IORD		0x02
#define REG			0x04
#define	NC8			0x08
#define RSET		0x10
#define WE			0x40
#define IOWR		0x80
#define set_OE   	PCTL |= OE
#define clr_OE   	PCTL &= ~OE
#define set_IORD    PCTL |= IORD
#define clr_IORD   	PCTL &= ~IORD
#define set_IOWR   	PCTL |= IOWR
#define clr_IOWR   	PCTL &= ~IOWR
#define set_WE   	PCTL |= WE
#define clr_WE   	PCTL &= ~WE
#define set_RSET   	PCTL |= RSET
#define clr_RSET   	PCTL &= ~RSET
#define set_REG   	PCTL |= REG
#define clr_REG   	PCTL &= ~REG
#define IREQ		RF5
//******************************************************************
//*	Modem Control Definitions
//******************************************************************
//#define CTS		  0x10
//#define RTS		  0x20
//#define set_RTS   PCOMM |= RTS
//#define clr_RTS   PCOMM &= ~RTS
//******************************************************************
//*	PORT TRIS Definitions
//******************************************************************
#define TO_NIC		TRISD = 0x00
#define FROM_NIC	TRISD = 0xFF
//RA1 = SENSOR DATA
//RA2 = SENSOR CLK
//0b11111011
#define SETUP_A	    TRISA = 0x0B;	\
					//LATA = 0xFF;
#define SETUP_C		TRISC = 0x80;
#define SETUP_E	    TRISE = 0x00;	\
					LATE = 0x00;
#define SETUP_F		TRISF = 0x28;	\
					LATF = 0xFB;
#define SETUP_G		TRISG = 0x00;	\
					LATG = 0xE0;	
			        //CE1 = 0;		
				    //CE2 = 1;


#define  BSS			0x01		//infrastructure network
#define  IBSS			0x02		//ad-hoc network
#define  SSID			0x03		//SSID for desired connection
#define  MAX_DATALEN	0x04		//Set maximum data length
#define  NIC_RATE		0x05		//Set NIC speeds
#define  WEP_KEYID		0x06		//use WEB Key 0-3
#define  WEP_KEY_64		0x07
#define  WEP_KEY_128	0x08		//WEP key value
#define  WEP_ON			0x09
#define  WEP_OFF		0x0A
#define  WEP_AUTH_SK	0x0B
#define  WEP_AUTH_OS	0x0C
#define  WEP_AUTH_ALL	0x0D

#define		disable_RXint	 RCIE = 0
#define		enable_RXint	 RCIE = 1
#define		enable_GLOBALint IPEN = 0;				\
							 GIE = 1;				\
							 PEIE = 1;
#define		disable_GLOBALint IPEN = 0;				\
							 GIE = 0;				\
							 PEIE = 0;

#define BAUD1	57600		//desired baud rate
#define FOSC	20000000	//oscillator frequency
#define DIVIDER1 ((unsigned int)(FOSC/(16 * BAUD1) -1))
//1,2,4,8,16,32,64,128 or 256 bytes 
#define USART_RX_BUFFER_SIZE  16      
#define USART_RX_BUFFER_MASK ( USART_RX_BUFFER_SIZE - 1 )
// 1,2,4,8,16,32,64,128 or 256 bytes 
#define USART_TX_BUFFER_SIZE  16      
#define USART_TX_BUFFER_MASK ( USART_TX_BUFFER_SIZE - 1 )

unsigned char USART_RxBuf[USART_RX_BUFFER_SIZE],USART_TxBuf[USART_TX_BUFFER_SIZE];
unsigned char USART_TxHead,USART_TxTail,USART_RxHead,USART_RxTail;

void delay_ms(char delay)
{
	char a,b,c;

	c = delay;
	do{
	a=0x06;
    do
    {
	b=0x00;
	while(--b);
	}while(--a);
    b=0x7B;
	while(--b);
	}while(--c);
}

unsigned int swapbytes(unsigned int val)
{
	char temphi,templo;
	
	temphi = make8(val,1);
	templo = make8(val,0);
	return(make16(templo,temphi));
}

void dump(unsigned int FID)
{
	unsigned int temp,i;
	 	temp = rd_cf_io16(Offset0_Register);
		if(!(temp & BAP0Busy_Bit_Mask))
		{
		 wr_cf_io16(FID,Select0_Register);
	     wr_cf_io16(0,Offset0_Register);
	     do{
			temp = rd_cf_io16(Offset0_Register);
		   }while(temp & BAP0Busy_Bit_Mask);
         
		 for(i=0;i<120;++i)
		  fidrid_buffer[i] = rd_cf_io16(Data0_Register);
         }
}

void putch(unsigned char c)
{
   while(!TRMT) 	// TRMT1 is set when TSR is empty
      continue;

  TXREG1 = c;		// load the register
}

//******************************************************************
//*	Init USART Function
//******************************************************************
void init_USART1(void)
{
  SPBRG1 = DIVIDER1;	//load baud rate divisor	
  TRISC7 = 1;			//receive pin
  TRISC6 = 0;			//transmit pin
  TXSTA1 = 0x04;		//high speed baud rate	
  RCSTA1 = 0x80;		//enable serial port and serial port pins

  
  USART_RxTail = 0x00;	//flush receive buffer 
  USART_RxHead = 0x00;
  USART_TxTail = 0x00;	//flush transmit buffer
  USART_TxHead = 0x00;
  RC1IP = 1;			//receive interrupt = high priority
  TX1IP = 1;			//transmit interrupt = high priority
  RC1IE = 1;			//enable receive interrupt
  PEIE = 1;				//enable all unmasked peripheral interrupts
  GIE = 1;				//enable all unmasked interrupts
  CREN = 1;			//enable USART1 receiver
  TX1IE = 0;			//disable USART1 transmit interrupt
  TXEN = 1;			//transmitter enabled
}

void interrupt USART(void)
{
  unsigned char data,tmphead,tmptail;

  if((TMR1IF) && (TMR1IE))
   {
		TMR1H = 0x80;
		TMR1IF = 0;
	    if(++secs == 60)
	     {
			secs = 0;
		 	++mins;
		 }
		if(mins == 60)
		 {
			mins = 0;
			++hours;
		 }
		if(hours == 24)
		 {
		    hours = 0;
		 }
	}

  if(RC1IF)
 {
   data = RCREG1;                   // read the received data 
                                // calculate buffer index 
   tmphead = ( USART_RxHead + 1 ) & USART_RX_BUFFER_MASK;
   USART_RxHead = tmphead;        // store new index 

   if ( tmphead == USART_RxTail )
   {
     // ERROR! Receive buffer overflow 
   }
                                
   USART_RxBuf[tmphead] = data;   // store received data in buffer 
  }

  
  if(TRMT)
  {
                                // check if all data is transmitted  
   if ( USART_TxHead != USART_TxTail )
   {
                                // calculate buffer index  
     tmptail = ( USART_TxTail + 1 ) & USART_TX_BUFFER_MASK;
     USART_TxTail = tmptail;      // store new index  

    TXREG1 = USART_TxBuf[tmptail];  // start transmition  
   }
   else
   {
     TX1IE = 0;         // disable TX interrupt  
   }
  }
}

int recvchar(void)
{
  unsigned char tmptail;
                                // wait for incomming data  
  while ( USART_RxHead == USART_RxTail );
                                // calculate buffer index  
  tmptail = ( USART_RxTail + 1 ) & USART_RX_BUFFER_MASK;
  USART_RxTail = tmptail;        // store new index  

  return USART_RxBuf[tmptail];   // return data  
}

int sendchar(int data)
{
  unsigned char tmphead;
                                /* calculate buffer index */
  tmphead = ( USART_TxHead + 1 ) & USART_TX_BUFFER_MASK;
                                /* wait for free space in buffer */
  while ( tmphead == USART_TxTail );
                                /* store data in buffer */
  USART_TxBuf[tmphead] = (unsigned char)data;
  USART_TxHead = tmphead;        /* store new index */

  TX1IE = 1;            /* enable TX interrupt */

  return data;
}

unsigned char CharInQueue(void)
{
  return(USART_RxHead != USART_RxTail);
}
//*******************************************************************************************************
//* Get Free BAP
//*******************************************************************************************************
char get_free_bap(void)
{
 	 unsigned int temp;
	 char rc;
	 
	 rc = 2;	 	  
     temp = rd_cf_io16(Offset1_Register);
	 if(!(temp & BAP1Busy_Bit_Mask))
	  rc = 1;
	 temp = rd_cf_io16(Offset0_Register);
	 if(!(temp & BAP0Busy_Bit_Mask))
	  rc = 0;
	 return(rc);
}	 
//*******************************************************************************************************
//* AIRDROP CONFIGURATION
//*******************************************************************************************************
char airdrop_cfg(unsigned int cmd) 
{
	char rc;
	unsigned int i,j,k;

	switch(cmd)
	{
		case BSS:
			fidrid_buffer[0] = RID_cfgPortType_Length;
			fidrid_buffer[1] = RID_cfgPortType;
			fidrid_buffer[2] = RID_cfgPortType_Infrastructure;
			rc = rid_write(RID_cfgPortType, fidrid_buffer, RID_cfgPortType_Length);
			//if(rc)
	  		 //printf("\r\nrid_write failed with return code %02X",rc);
         	break;
		case IBSS:		
			fidrid_buffer[0] = RID_cfgPortType_Length;
			fidrid_buffer[1] = RID_cfgPortType;
			fidrid_buffer[2] = RID_cfgPortType_IBSS;
			rc = rid_write(RID_cfgPortType, fidrid_buffer, RID_cfgPortType_Length);
			//if(rc)
	  		 //printf("\r\nrid_write failed with return code %02X",rc);
         	break;
			
	    case SSID:
			fidrid_buffer[0] = RID_DesiredSSID_Length;
			fidrid_buffer[1] = RID_cfgDesiredSSID;
			fidrid_buffer[2] = strlen(ssid);
    		j = strlen(ssid);
			i=0;
			k=3;
			while(j > 1)
			{
	 		 fidrid_buffer[k] = (ssid[i+1] << 8) | ssid[i];
	 		 i+=2;
	 		 ++k;
	   		 j-=2; 	
			}
	   		while(j > 0)
			{
	 		 fidrid_buffer[k] = ssid[i];
	 		 --j;	
			}

			rc = rid_write(RID_cfgDesiredSSID,fidrid_buffer,RID_DesiredSSID_Length);
			break;

		case MAX_DATALEN:
			fidrid_buffer[0] = RID_cfgMaxDataLength_Length;
			fidrid_buffer[1] = RID_cfgMaxDataLength;
			fidrid_buffer[2] = RID_cfgMaxDataLength_Value;  //0x05DC - 1500 decimal
			rc = rid_write(RID_cfgMaxDataLength, fidrid_buffer, RID_cfgMaxDataLength_Length);
			break;

		case NIC_RATE:
			fidrid_buffer[0] = RID_TxRateControl_Length;
			fidrid_buffer[1] = RID_TxRateControl;
			fidrid_buffer[2] = RID_TxRateControl_Value_ALL;
			rc = rid_write(RID_TxRateControl, fidrid_buffer, RID_TxRateControl_Length);
			break;

		case WEP_KEYID:
			fidrid_buffer[0] = RID_cfgWEPDefaultKeyID_Length;
			fidrid_buffer[1] = RID_cfgWEPDefaultKeyID;
			fidrid_buffer[2] = RID_cfgWEPDefaultKeyID_Value0;
			rc = rid_write(RID_cfgWEPDefaultKeyID, fidrid_buffer, RID_cfgWEPDefaultKeyID_Length);
			break;

	    case WEP_KEY_64:
			fidrid_buffer[0] = RID_Default64Key_Length;
			fidrid_buffer[1] = RID_cfgDefaultKey0;
    		j = strlen(wepkey);
			i=0;
			k=2;
			while(j > 1)
			{
	 		 fidrid_buffer[k] = (wepkey[i+1] << 8) | wepkey[i];
	 		 i+=2;
	 		 ++k;
	   		 j-=2; 	
			}
	   		while(j > 0)
			{
	 		 fidrid_buffer[k] = wepkey[i];
	 		 --j;	
			}

			rc = rid_write(RID_cfgDefaultKey0,fidrid_buffer,RID_Default128Key_Length);
			break;

	    case WEP_KEY_128:
			fidrid_buffer[0] = RID_Default128Key_Length;
			fidrid_buffer[1] = RID_cfgDefaultKey0;
    		j = strlen(wepkey);
			i=0;
			k=2;
			while(j > 1)
			{
	 		 fidrid_buffer[k] = (wepkey[i+1] << 8) | wepkey[i];
	 		 i+=2;
	 		 ++k;
	   		 j-=2; 	
			}
	   		while(j > 0)
			{
	 		 fidrid_buffer[k] = wepkey[i];
	 		 --j;	
			}

			rc = rid_write(RID_cfgDefaultKey0,fidrid_buffer,RID_Default128Key_Length);
			break;
		
		case WEP_ON:
			fidrid_buffer[0] = RID_cfgWEPFlags_Length;
			fidrid_buffer[1] = RID_cfgWEPFlags;
			fidrid_buffer[2] = RID_cfgWEPFlags_Value_ON;
			rc = rid_write(RID_cfgWEPFlags, fidrid_buffer, RID_cfgWEPFlags_Length);
			break;

		case WEP_OFF:
			fidrid_buffer[0] = RID_cfgWEPFlags_Length;
			fidrid_buffer[1] = RID_cfgWEPFlags;
			fidrid_buffer[2] = RID_cfgWEPFlags_Value_OFF;
			rc = rid_write(RID_cfgWEPFlags, fidrid_buffer, RID_cfgWEPFlags_Length);
			break;

		case WEP_AUTH_SK:
			fidrid_buffer[0] = RID_cfgAuthentication_Length;
			fidrid_buffer[1] = RID_cfgAuthentication;
			fidrid_buffer[2] = RID_cfgAuthentication_Value_SK;
			rc = rid_write(RID_cfgAuthentication, fidrid_buffer, RID_cfgAuthentication_Length);
			break;

		case WEP_AUTH_OS:
			fidrid_buffer[0] = RID_cfgAuthentication_Length;
			fidrid_buffer[1] = RID_cfgAuthentication;
			fidrid_buffer[2] = RID_cfgAuthentication_Value_OS;
			rc = rid_write(RID_cfgAuthentication, fidrid_buffer, RID_cfgAuthentication_Length);
			break;

		case WEP_AUTH_ALL:
			fidrid_buffer[0] = RID_cfgAuthentication_Length;
			fidrid_buffer[1] = RID_cfgAuthentication;
			fidrid_buffer[2] = RID_cfgAuthentication_Value_OK;
			rc = rid_write(RID_cfgAuthentication, fidrid_buffer, RID_cfgAuthentication_Length);
			break;

		default:		
			rc = 1;
			break;
	}
	return(rc);
}
//*******************************************************************************************************
//* rid_write
//*******************************************************************************************************
char rid_write(unsigned int fidrid, unsigned int* buffer, unsigned int count)
{
	char rc;
	
	rc = bap_write(fidrid, 0x0000, (char*) buffer, (count+1)<<1);
	rc = send_command(Access_Cmd | AccessWrite_Mask, fidrid);
	return(rc);
}

//*******************************************************************************************************
//* bap_write
//*******************************************************************************************************
char bap_write(unsigned int fidrid,unsigned int offset,char* buffer, unsigned int count)
{
	unsigned int temp;
	char rc,bapnum;
	
	bapnum = get_free_bap();
	rc = 0;
	switch(bapnum)
	{
	 case 0:
	  wr_cf_io16(fidrid,Select0_Register);
	  wr_cf_io16(offset,Offset0_Register);
	  do{
		 temp = rd_cf_io16(Offset0_Register);
	    }while(temp & BAP0Busy_Bit_Mask);
	  temp = rd_cf_io16(Offset0_Register);
	  if(temp & BAP0Err_Bit_Mask)
	   rc=1;
	  else
	   wr_cf_data(BAP0,buffer,count);
	  break;
	  
	  case 1:
       wr_cf_io16(fidrid,Select1_Register);
	   wr_cf_io16(offset,Offset1_Register);
	   do{
		  temp = rd_cf_io16(Offset1_Register);
		 }while(temp & BAP1Busy_Bit_Mask);
	   temp = rd_cf_io16(Offset1_Register);
	   if(temp & BAP1Err_Bit_Mask)
	    rc=1;
	   else
		wr_cf_data(BAP1,buffer,count);
       break;	
	}
	
	return(rc);
}

//*******************************************************************************************************
//* rid_read
//*******************************************************************************************************
char rid_read(unsigned int rid)
{
	unsigned int temp;
	char rc;
	
	rc = 0;
	temp = send_command(Access_Cmd,rid);
	//if (temp)
	//	printf("\r\nrid_read: Access read RID: %04X command sent with return code: %02X", rid, temp);
   //else
   	//printf("\r\nrid_read: Access read command sent successfully, try reading RID: %04X", rid);

	temp = fid_read(rid);		
	if (temp)
		rc=1;
  
	return(rc);
}

//*******************************************************************************************************
//* fid_read
//*******************************************************************************************************
char fid_read(unsigned int fid)
{
	unsigned int temp;
	unsigned int fidlen;
	unsigned int fidpointer;
	char rc,bapnum;

	bapnum = get_free_bap();
	rc = 0;
	switch(bapnum)
	{
	 case 0:
	  wr_cf_io16(fid,Select0_Register);
	  wr_cf_io16(0x0000,Offset0_Register);
	  do{
		 temp = rd_cf_io16(Offset0_Register);
	    }while(temp & BAP0Busy_Bit_Mask);
	  temp = rd_cf_io16(Offset0_Register);
	  if(temp & BAP0Err_Bit_Mask)
	   rc = 1;
	  else
	  {
	   fidlen = rd_cf_io16(Data0_Register);
       fidrid_buffer[0] = fidlen;
	    if(fidlen)
		 {
		  for(fidpointer=0;fidpointer<fidlen;fidpointer++)
		   fidrid_buffer[fidpointer+1] = rd_cf_io16(Data0_Register);
	      rc = 0;
	     }
	   }
	 break;
	
	 case 1:
	  wr_cf_io16(fid,Select1_Register);
	  wr_cf_io16(0x0000,Offset1_Register);
	  do{
		 temp = rd_cf_io16(Offset1_Register);
		}while(temp & BAP1Busy_Bit_Mask);
      temp = rd_cf_io16(Offset1_Register);
	  if(temp & BAP1Err_Bit_Mask)
       rc = 1;
	  else
      {
	   fidlen = rd_cf_io16(Data1_Register);
	   fidrid_buffer[0] = fidlen;
	   if(fidlen)
	   {
		for(fidpointer=0;fidpointer<fidlen;fidpointer++)
	    {
		 fidrid_buffer[fidpointer+1] = rd_cf_io16(Data1_Register);
	    }
	   } 
	  }
	  break;
	  default:
	   rc =1 ;
	   break;
	 }  
	return(rc);
}
	
//*******************************************************************************************************
//* rid_string_write
//*******************************************************************************************************
void rid_string_write(unsigned int fidrid, unsigned int ridlen, unsigned int* buffer)
{
	
	unsigned int i,j,k;
	//char tempstring[] = "AIRDROP_NETWORK";
	//char tempstring[] = "";

	fidrid_buffer[0] = ridlen;
	fidrid_buffer[1] = fidrid;
	fidrid_buffer[2] = strlen(ssid);
    j = strlen(ssid);
	i=0;
	k=3;
	while(j > 1)
	{
	 fidrid_buffer[k] = (ssid[i+1] << 8) | ssid[i];
	 i+=2;
	 ++k;
	 j-=2; 	
	}
	while(j > 0)
	{
	 fidrid_buffer[k] = ssid[i];
	 --j;	
	}

	rid_write(fidrid,buffer,ridlen);
	
}
void buffer_alloc_event_handler(void)
{
	unsigned int FID;
	char i,j;

	FID = rd_cf_io16(AllocFID_Register);
	j = 1;
	for(i=0;i<3;++i)
	{
	 if(TxFID_buffers[i] == FID)
      bitset(free_TxFIDs, i);
	  j = 0;		
	  //printf("\r\nReclaimed Buffer %04X", FID);
    }
	if(j)
	 {
	  if(!(free_TxFIDs & 0x01))
	  {
       TxFID_buffers[0] = FID;
       bitset(free_TxFIDs, 0);
	  }
	  else if(!(free_TxFIDs & 0x02)) 
	  {
       TxFID_buffers[1] = FID;
       bitset(free_TxFIDs, 1);
	  }
	  else if(!(free_TxFIDs & 0x04)) 
	  {
       TxFID_buffers[2] = FID;
       bitset(free_TxFIDs, 2);
	  }
	 }
}

//*******************************************************************************************************
//* Perform Housekeeping on Events
//*******************************************************************************************************
void do_event_housekeeping(void)
{
	unsigned int evstat_data,FID;

	evstat_data = rd_cf_io16(EvStat_Register);
	
	if(evstat_data & EvStat_Tx_Bit_Mask)
	{
	 //printf("\r\nTransmit Event Occurred");
	 wr_cf_io16(EvStat_Tx_Bit_Mask,EvAck_Register);
	}

	if(evstat_data & EvStat_TxExc_Bit_Mask)
	{
	 //printf("\r\nTransmit Event Exception Occurred");
	 wr_cf_io16(EvStat_TxExc_Bit_Mask,EvAck_Register);
	}

	if(evstat_data & EvStat_Alloc_Bit_Mask)
	{
	 //printf("\r\nBuffer Allocation Event Occurred");
	 buffer_alloc_event_handler();
	 wr_cf_io16(EvStat_Tx_Bit_Mask,EvAck_Register);
	}

	if(evstat_data & EvStat_Cmd_Bit_Mask)
	{
	 //printf("\r\nCommand Completed Event Occurred");
	 wr_cf_io16(EvStat_Cmd_Bit_Mask,EvAck_Register);
	}

	if(evstat_data & EvStat_Info_Bit_Mask)
	{
	 //printf("\r\nInformation Frame Received Event Occurred");
	 FID = rd_cf_io16(InfoFID_Register);
	 //printf("\r\nInformation FID: %04X", FID);
	 wr_cf_io16(EvStat_Info_Bit_Mask,EvAck_Register);
	}

	if(evstat_data & EvStat_InfDrop_Bit_Mask)
	{
	 //printf("\r\nUnsolicited Information Frame Dropped Event Occurred");
	 wr_cf_io16(EvStat_InfDrop_Bit_Mask,EvAck_Register);
	}

	if(evstat_data & EvStat_WTErr_Bit_Mask)
	{
	 //printf("\r\nWait Error Event Occurred");
	 wr_cf_io16(EvStat_WTErr_Bit_Mask,EvAck_Register);
	}
}
//******************************************************************
//*	IP Protocol Types
//******************************************************************
#define	PROT_ICMP			   0x01
#define	PROT_TCP			   0x06
#define	PROT_UDP			   0x11
//******************************************************************
//*	Ethernet Header Layout
//******************************************************************
unsigned int packet[761]; 
#define enetpacketLen11		   0x00	
#define enetpacketDest		   0x01
#define	enetpacketDest01	   0x01  //destination mac address
#define	enetpacketDest23	   0x02
#define	enetpacketDest45	   0x03
#define enetpacketSrc	       0x04
#define	enetpacketSrc01		   0x04  //source mac address
#define	enetpacketSrc23		   0x05
#define	enetpacketSrc45		   0x06
#define enetpacketLen03		   0x07
#define enetpacketSnap		   0x08
#define enetpacketCntrl		   0x09
//							   0x0A
#define	enetpacketType		   0x0B  //type/length field
#define enetpacketData         0x0C  //IP data area begins here
//******************************************************************
//*	ARP Layout
//******************************************************************
#define	arp_hwtype			   0x0C
#define	arp_prtype			   0x0D
#define	arp_hwprlen			   0x0E
#define	arp_op		   		   0x0F
#define	arp_shaddr			   0x10   //arp source mac address
//							   0x11
//							   0x12	
#define	arp_sipaddr			   0x13   //arp source ip address
//							   0x14
#define	arp_thaddr			   0x15   //arp target mac address
//							   0x16
//							   0x17	
#define	arp_tipaddr			   0x18   //arp target ip address
//                             0x19
//******************************************************************
//*	IP Header Layout
//******************************************************************
#define	ip_vers_len			   0x0C	//IP version and header length
//#define	ip_tos			   		//IP type of service
#define	ip_pktlen			   0x0D //packet length
#define	ip_id				   0x0E	//datagram id
#define	ip_frag_offset		   0x0F	//fragment offset
#define	ip_ttlproto			   0x10	//time to live
//#define	ip_proto			    //protocol (ICMP=1, TCP=6, UDP=11)
#define	ip_hdr_cksum		   0x11	//header checksum
#define	ip_srcaddr			   0x12	//IP address of source
//							   0X13				
#define	ip_destaddr			   0x14	//IP addess of destination
//                             0X15
#define	ip_data				   0x16	//IP data area
//******************************************************************
//*	TCP Header Layout
//******************************************************************
#define	TCP_srcport			   0x16	//TCP source port
#define	TCP_destport   	  	   0x17	//TCP destination port
#define	TCP_seqnum  	       0x18	//sequence number
//							   0x19		
#define	TCP_acknum	           0x1A	//acknowledgement number
//							   0x1B
#define	TCP_hdrflags		   0x1C	//4-bit header len and flags
#define	TCP_window			   0x1D	//window size
#define	TCP_cksum		       0x1E	//TCP checksum
#define	TCP_urgentptr   	   0x1F	//urgent pointer
#define TCP_data               0x20 //option/data
//******************************************************************
//*	TCP Flags
//*   IN flags represent incoming bits
//*   OUT flags represent outgoing bits
//******************************************************************
#define  FIN_IN               (packet[TCP_hdrflags] & 0x0100)
#define  SYN_IN               (packet[TCP_hdrflags] & 0x0200)
#define  RST_IN               (packet[TCP_hdrflags] & 0x0400)
#define  PSH_IN               (packet[TCP_hdrflags] & 0x0800)
#define  ACK_IN               (packet[TCP_hdrflags] & 0x1000)
#define  URG_IN               (packet[TCP_hdrflags] & 0x2000)
#define  FIN_OUT              packet[TCP_hdrflags] |= 0x0100 //0000 0001 0000 0000
#define  SYN_OUT              packet[TCP_hdrflags] |= 0x0200 //0000 0010 0000 0000
#define  RST_OUT              packet[TCP_hdrflags] |= 0x0400 //0000 0100 0000 0000
#define  PSH_OUT              packet[TCP_hdrflags] |= 0x0800 //0000 1000 0000 0000
#define  ACK_OUT              packet[TCP_hdrflags] |= 0x1000 //0001 0000 0000 0000
#define  URG_OUT              packet[TCP_hdrflags] |= 0x2000 //0010 0000 0000 0000
//******************************************************************
//*	ICMP Header
//******************************************************************
#define	ICMP_typecode		   ip_data
//#define	ICMP_code		   ICMP_type+1
#define	ICMP_cksum			   ICMP_typecode+1
#define	ICMP_id				   ICMP_cksum+1
#define	ICMP_seqnum			   ICMP_id+1
#define  ICMP_data             ICMP_seqnum+1
//******************************************************************
//*	UDP Header
//******************************************************************
#define	UDP_srcport			   ip_data
#define	UDP_destport		   UDP_srcport+1
#define	UDP_len				   UDP_destport+1
#define	UDP_cksum			   UDP_len+1
#define	UDP_data			   UDP_cksum+1
//******************************************************************
//*	UDP Packet Layout
//******************************************************************
//******************************************************************
//*	Ethernet Header Layout
//******************************************************************
unsigned int udp_packet[33];                   
#define enetpacketLen11		   0x00	
#define enetpacketDest		   0x01
#define	enetpacketDest01	   0x01  //destination mac address
#define	enetpacketDest23	   0x02
#define	enetpacketDest45	   0x03
#define enetpacketSrc	       0x04
#define	enetpacketSrc01		   0x04  //source mac address
#define	enetpacketSrc23		   0x05
#define	enetpacketSrc45		   0x06
#define enetpacketLen03		   0x07
#define enetpacketSnap		   0x08
#define enetpacketCntrl		   0x09
//							   0x0A
#define	enetpacketType		   0x0B  //type/length field
#define enetpacketData         0x0C  //IP data area begins here
//******************************************************************
//*	IP Header Layout
//******************************************************************
#define	ip_vers_len			   0x0C	//IP version and header length
//#define	ip_tos			   		//IP type of service
#define	ip_pktlen			   0x0D //packet length
#define	ip_id				   0x0E	//datagram id
#define	ip_frag_offset		   0x0F	//fragment offset
#define	ip_ttlproto			   0x10	//time to live
//#define	ip_proto			    //protocol (ICMP=1, TCP=6, UDP=11)
#define	ip_hdr_cksum		   0x11	//header checksum
#define	ip_srcaddr			   0x12	//IP address of source
//							   0X13				
#define	ip_destaddr			   0x14	//IP addess of destination
//                             0X15
#define	ip_data				   0x16	//IP data area
//******************************************************************
//*	UDP Header
//******************************************************************
#define	UDP_srcport			   ip_data
#define	UDP_destport		   UDP_srcport+1
#define	UDP_len				   UDP_destport+1
#define	UDP_cksum			   UDP_len+1
#define	UDP_data			   UDP_cksum+1
//******************************************************************
//*	Get A Frame From the CF Receive Buffer
//*   This routine removes an Ethernet frame from the receive buffer.
//******************************************************************
void get_frame()
{
	unsigned int temp,i;
	char rc,bapnum;

	rc = 0;
	RxFID = rd_cf_io16(RxFID_Register);	// Get the FID of the allocated buffer
	bapnum = get_free_bap();
	switch(bapnum)
	{
	 case 0:
	  wr_cf_io16(RxFID,Select0_Register);
	  wr_cf_io16(rxdatalength_offset,Offset0_Register);
	  do{
		 temp = rd_cf_io16(Offset0_Register);
	    }while(temp & BAP0Busy_Bit_Mask);
	  //READ 802.11B PACKET DATA LENGTH
      packet[enetpacketLen11] = rd_cf_io16(Data0_Register);
	  //CHECK FOR PACKET DATA LENGTH > 1500 BYTES	
      if(packet[enetpacketLen11] > 0x05DC)
       packet[enetpacketLen11] = 0x05DC;
	  //GET DESTINATION MAC ADDRESS
	  for(i=0;i<3;++i)
	   packet[enetpacketDest+i] = rd_cf_io16(Data0_Register);
	  //GET SOURCE MAC ADDRESS
	  for(i=0;i<3;++i)
	   packet[enetpacketSrc+i] = rd_cf_io16(Data0_Register);
	  //GET PACKET DATA	
	  for(i=0;i<packet[enetpacketLen11];++i)
	   packet[enetpacketLen03+i] = rd_cf_io16(Data0_Register);
	  //ACKNOWLEDGE THAT WE NOW OWN THE FID	
      wr_cf_io16(EvStat_Rx_Bit_Mask,EvAck_Register );	
	  break;
	     
	 case 1:  
      wr_cf_io16(RxFID,Select1_Register);
	  wr_cf_io16(rxdatalength_offset,Offset1_Register);
	  do{
		 temp = rd_cf_io16(Offset1_Register);
		}while(temp & BAP0Busy_Bit_Mask);
      packet[enetpacketLen11] = rd_cf_io16(Data1_Register);	//get data length
      if(packet[enetpacketLen11] > 0x05DC)
       packet[enetpacketLen11] = 0x05DC;
	  for(i=0;i<3;++i)
       packet[enetpacketDest+i] = rd_cf_io16(Data1_Register);
	  for(i=0;i<3;++i)
	   packet[enetpacketSrc+i] = rd_cf_io16(Data1_Register);
	  for(i=0;i<packet[enetpacketLen11];++i)  //removed +1
	   packet[enetpacketLen03+i] = rd_cf_io16(Data1_Register);
      wr_cf_io16(EvStat_Rx_Bit_Mask,EvAck_Register );	// Acknowledge we own the FID
	  break;
     default:	 
	   rc = 1;	  
	   break;
	}   
   if(!rc)
   {			 
   //process an ARP packet
   if(packet[enetpacketType] == 0x0608)
   {
      if(packet[arp_hwtype] == 0x0100 && 
	   packet[arp_prtype] == 0x0008 && 
	   packet[arp_hwprlen] == 0x0406 && 
	   packet[arp_op] == 0x0100 && 
       ipaddri[0] == packet[arp_tipaddr] &&
       ipaddri[1] == packet[arp_tipaddr+1])
       arp();
      if(packet[arp_hwtype] == 0x0100 && 
	   packet[arp_prtype] == 0x0008 && 
	   packet[arp_hwprlen] == 0x0406 && 
	   packet[arp_op] == 0x0200 && 
       ipaddri[0] == packet[arp_tipaddr] &&
       ipaddri[1] == packet[arp_tipaddr+1])
	   {
       	for(i=0;i<6;i++)
    	{
			if(i%2)
				remotemacaddrc[i] = packet[arp_shaddr+i/2]>>8;
			else
				remotemacaddrc[i] = packet[arp_shaddr+i/2] & 0xFF;
    	}
		remotemacaddri[0] = make16(remotemacaddrc[1],remotemacaddrc[0]);
		remotemacaddri[1] = make16(remotemacaddrc[3],remotemacaddrc[2]);
		remotemacaddri[2] = make16(remotemacaddrc[5],remotemacaddrc[4]);
		set_arpflag;
       }
	}
   //process an IP packet
   else if(packet[enetpacketType] == 0x0008 
		  && packet[ip_destaddr] == ipaddri[0]   
          && packet[ip_destaddr+1] == ipaddri[1])  

   {
      if(HIGH_BYTE(packet[ip_ttlproto]) == PROT_ICMP)
         icmp();
      else if(HIGH_BYTE(packet[ip_ttlproto]) == PROT_UDP)
         udp();
      else if(HIGH_BYTE(packet[ip_ttlproto]) == PROT_TCP)
         tcp();
   }
  }
   else
   do_event_housekeeping();
}
//******************************************************************
//*	Perform ARP Response
//*   This routine supplies a requesting computer with the
//*   Ethernet modules's MAC (hardware) address.
//******************************************************************
char arp(void)
{
	unsigned int TxFID,i;
	char rc;

	rc = 0;
	TxFID = get_free_TxFID();
	if(TxFID == 0)
	 rc = 1;
	else
	{ 
	 for(i=0;i<2;++i)
     { 
	  packet[arp_tipaddr+i] = packet[arp_sipaddr+i];
	  packet[arp_sipaddr+i] = ipaddri[i];
	 } 
	 for(i=0;i<3;++i)
     {
	  packet[enetpacketDest+i] = packet[enetpacketSrc+i];
	  packet[arp_thaddr+i] = packet[enetpacketSrc+i];
	  packet[enetpacketSrc+i] = macaddri[i];
	  packet[arp_shaddr+i] = macaddri[i];
	 }
	 packet[arp_op] = 0x0200;	//arp reply
     rc = bap_write(TxFID,rxdatalength_offset,(char*)packet, packet[enetpacketLen11]+16);
	 rc=send_command(TransmitReclaim_Cmd,TxFID);
	 
     do_event_housekeeping();
    } 
   return(rc);
 }
//******************************************************************
//*	Perform ARP Request
//*   This routine uses a known remote IP address to get a remote
//*   Ethernet modules's MAC (hardware) address.
//******************************************************************
char arp_request(void)
{
	unsigned int TxFID,i,bytecount;
	char rc;

	clr_arpflag;
	bytecount = 0x0000;
	rc = 0;
	TxFID = get_free_TxFID();
	if(TxFID == 0)
	 rc = 1;
	else
	{ 
	packet[enetpacketSnap] = 0xAAAA;	//SAP
	packet[enetpacketCntrl] = 0x0003;	//unnumbered frame:UI
	packet[enetpacketCntrl+1] = 0x0000;	//OUI
	packet[enetpacketType] = 0x0608;	//ARP packet type
	packet[arp_hwtype] = 0x0100;		//hardware type = 10Mb Ethernet
	packet[arp_prtype] = 0x0008;		//IP protocol
    packet[arp_hwprlen] = 0x0406; 	 	//hardware addr len (06)/protocol addr len(04)
	packet[arp_op] = 0x0100;			//ARP request
	bytecount += 16;
	for(i=0;i<3;++i)
    {
      packet[enetpacketDest+i] = 0xFFFF;		//target MAC addr
	  packet[enetpacketSrc+i] = macaddri[i];	//sender's MAC addr
	  packet[arp_shaddr+i] = macaddri[i];		//sender's MAC addr
	  packet[arp_thaddr+i] = 0x0000;			//target MAC addr
	 }
	bytecount += 24;
	 for(i=0;i<2;++i)
     { 
	  packet[arp_tipaddr+i] = remoteipaddri[i];	//target ip addr
	  packet[arp_sipaddr+i] = ipaddri[i];		//source ip addr
	 } 
	bytecount += 8;
	bytecount +=6;
	packet[enetpacketLen11] = bytecount;
	packet[enetpacketLen03] = swapbytes(bytecount);
     rc = bap_write(TxFID,rxdatalength_offset,(char*)packet, packet[enetpacketLen11]+16);
	 rc=send_command(TransmitReclaim_Cmd,TxFID);
	 
     do_event_housekeeping();
    } 

   return(rc);
 }
//******************************************************************
//*	Perform ICMP Function
//*   This routine responds to a ping.
//******************************************************************
	unsigned int iphdrlen,ippktlen;	
    char tempcH,tempcL;

void icmp()
{
	char rc;
   //set echo reply
   packet[ICMP_typecode]=0x00;

   //clear the ICMP checksum
   packet[ICMP_cksum]=0x00;

   //setup the IP header
   setipaddrs();

   //calculate the ICMP checksum
   hdr_chksum =0;
   ippktlen=swapbytes(packet[ip_pktlen]);
   iphdrlen =(LOW_BYTE(packet[ip_vers_len]) & 0x0F) *4;
   	
   hdrlen = ippktlen - iphdrlen;
   addr = &packet[ICMP_typecode];
   cksum();
   packet[ICMP_cksum]= ~(hdr_chksum + ((hdr_chksum & 0xFFFF0000) >> 16));
   //send the ICMP packet along on its way
   rc = echo_packet();
}
//******************************************************************
//*	init_udp Function
//*   This function sends UDP packet
//******************************************************************
void init_udp()
{
	char temp[2];

	udp_packet[enetpacketLen11] = 0x0036;
   	udp_packet[enetpacketDest01]=remotemacaddri[0];
   	udp_packet[enetpacketDest23]=remotemacaddri[1];
   	udp_packet[enetpacketDest45]=remotemacaddri[2];
   	udp_packet[enetpacketSrc01]=macaddri[0];
   	udp_packet[enetpacketSrc23]=macaddri[1];
   	udp_packet[enetpacketSrc45]=macaddri[2];
	udp_packet[enetpacketLen03] = 0x3600;
	udp_packet[enetpacketSnap] = 0xAAAA;
	udp_packet[enetpacketCntrl] = 0x0003;
	udp_packet[enetpacketCntrl+1] = 0x0000;
	udp_packet[enetpacketType] = 0x0008;
	udp_packet[ip_vers_len] = 0x0045;
	udp_packet[ip_pktlen] = 0x2400;
	udp_packet[ip_id] = ++cntri;
	udp_packet[ip_frag_offset] = 0x0000;
	udp_packet[ip_ttlproto] = 0x1180;
	//upd_packet[ip_hdr_cksum] = 0x0000;
   	udp_packet[ip_srcaddr]=ipaddri[0];
   	udp_packet[ip_srcaddr+1]=ipaddri[1];
   	udp_packet[ip_destaddr]=remoteipaddri[0];
   	udp_packet[ip_destaddr+1]=remoteipaddri[1];
	temp[0] = make8(udpaddrs[local_udpaddr],0);
	temp[1] = make8(udpaddrs[local_udpaddr],1); 
   	udp_packet[UDP_srcport] = make16(temp[0],temp[1]); //0x8813;
   	//udp_packet[UDP_destport] = 0x0900;
	udp_packet[UDP_len] = 0x1000;
	//udp_packet[UDP_cksum] = 0x0000;
	//udp_packet[UDP_data] = 0x5454;
	//udp_packet[UDP_data+1] = 0x4E43;
	//udp_packet[UDP_data+2] = 0x5454;
	//udp_packet[UDP_data+3] = 0x4E43;
}

//******************************************************************
//*	send_udp Function
//*   This function sends UDP data
//******************************************************************
char send_udp(void)
{
	unsigned int TxFID;
	char rc,timer,temp[2];

   //this is all done in init_udp for sensor app	
   //setup destination IP address
   //packet[ip_destaddr]=remoteipaddri[0];
   //packet[ip_destaddr+1]=remoteipaddri[1];
   //make AirDrop module IP address source address
   //packet[ip_srcaddr]=ipaddri[0];
   //packet[ip_srcaddr+1]=ipaddri[1];
   //move hardware source address to destination address
   //packet[enetpacketDest01]=remotemacaddri[0];
   //packet[enetpacketDest23]=remotemacaddri[1];
   //packet[enetpacketDest45]=remotemacaddri[2];
   //make AirDrop module mac address the source address
   //packet[enetpacketSrc01]=macaddri[0];
   //packet[enetpacketSrc23]=macaddri[1];
   //packet[enetpacketSrc45]=macaddri[2];
   
   timer = secs;
   timer += 10;
   do{
   		sht_connectionreset();
		error=0;
    	error+=sht_measure(&humi_val,&humi_chksum,HUMI);  //measure humidity
    	error+=sht_measure(&temp_val,&temp_chksum,TEMP);  //measure temperature
    }while (error!=0 && secs < timer); 

	udp_packet[UDP_data] = temp_val;
	udp_packet[UDP_data+1] = make16(0x00,temp_chksum);
	udp_packet[UDP_data+2] = humi_val;
	udp_packet[UDP_data+3] = make16(0x00,humi_chksum);

   //calculate the IP header checksum
   udp_packet[ip_hdr_cksum]=0x00;

   hdr_chksum =0;
   hdrlen = (LOW_BYTE(udp_packet[ip_vers_len]) & 0x0F) *4;
   addr = &udp_packet[ip_vers_len];
   cksum();
   udp_packet[ip_hdr_cksum]= ~(hdr_chksum + ((hdr_chksum & 0xFFFF0000) >> 16));

	temp[0] = make8(udpaddrs[remote_udpaddr],0);
	temp[1] = make8(udpaddrs[remote_udpaddr],1); 
   	udp_packet[UDP_destport] = make16(temp[0],temp[1]);

   //calculate the UDP checksum
   udp_packet[UDP_cksum] = 0x00;
   hdr_chksum =0;
   hdrlen = 0x08;
   addr = &udp_packet[ip_srcaddr];
   cksum();
   hdr_chksum = hdr_chksum + ((256*HIGH_BYTE(udp_packet[ip_ttlproto]))+udp_packet[UDP_len]);
   hdrlen = swapbytes(udp_packet[UDP_len]);
   addr = &udp_packet[UDP_srcport];
   cksum();
   udp_packet[UDP_cksum]= ~(hdr_chksum + ((hdr_chksum & 0xFFFF0000) >> 16));
      //echo the incoming data back to the VB program

	TxFID = get_free_TxFID();
	if(TxFID == 0)
	 rc = 1;
	else
	{
     rc = bap_write(TxFID,rxdatalength_offset,(char*)udp_packet,udp_packet[enetpacketLen11]+16);
	 if(rc=send_command(TransmitReclaim_Cmd,TxFID))
		printf("\r\nTransmit failed");
	 else
 
	  printf("\r\nSending UDP Data Packet to UDP port %d..\r\n",make16(temp[1],temp[0]));
	 rh_lin = C3 * humi_val * humi_val + C2 * humi_val + C1;
	 rh_true = ((temp_val*0.01) - 39.63) * (T1+T2*humi_val) + rh_lin;
	 if(rh_true > 100)
	 	rh_true = 100;
	 if(rh_true < 0.1)
	 	rh_true = 0.1;
	 printf("%3.2fC %3.2fF %d%%\r\n",(temp_val*0.01) - 39.63,(temp_val*0.018) - 39.31,rh_true);
	 
     do_event_housekeeping();
	}
	return(rc);
 }
//******************************************************************
//*	send_udp_discard Function
//*   This function sends a dummy UDP data
//******************************************************************
char send_udp_discard(void)
{
	unsigned int TxFID;
	char rc;

	printf("\r\nSending Dummy UDP Packet To Discard Port 9..");

   //this is all done in init_udp for sensor app	
   //setup destination IP address
   //packet[ip_destaddr]=remoteipaddri[0];
   //packet[ip_destaddr+1]=remoteipaddri[1];
   //make AirDrop module IP address source address
   //packet[ip_srcaddr]=ipaddri[0];
   //packet[ip_srcaddr+1]=ipaddri[1];
   //move hardware source address to destination address
   //packet[enetpacketDest01]=remotemacaddri[0];
   //packet[enetpacketDest23]=remotemacaddri[1];
   //packet[enetpacketDest45]=remotemacaddri[2];
   //make AirDrop module mac address the source address
   //packet[enetpacketSrc01]=macaddri[0];
   //packet[enetpacketSrc23]=macaddri[1];
   //packet[enetpacketSrc45]=macaddri[2];

	udp_packet[UDP_data] = 0x5454;
	udp_packet[UDP_data+1] = 0x4E43;
	udp_packet[UDP_data+2] = 0x5454;
	udp_packet[UDP_data+3] = 0x4E43;

   //calculate the IP header checksum
   udp_packet[ip_hdr_cksum]=0x00;

   hdr_chksum =0;
   hdrlen = (LOW_BYTE(udp_packet[ip_vers_len]) & 0x0F) *4;
   addr = &udp_packet[ip_vers_len];
   cksum();
   udp_packet[ip_hdr_cksum]= ~(hdr_chksum + ((hdr_chksum & 0xFFFF0000) >> 16));

   udp_packet[UDP_destport] = 0x0900;
   //packet[UDP_srcport] = 0x8813;
   //calculate the UDP checksum
   udp_packet[UDP_cksum] = 0x00;
   hdr_chksum =0;
   hdrlen = 0x08;
   addr = &udp_packet[ip_srcaddr];
   cksum();
   hdr_chksum = hdr_chksum + ((256*HIGH_BYTE(udp_packet[ip_ttlproto]))+udp_packet[UDP_len]);
   hdrlen = swapbytes(udp_packet[UDP_len]);
   addr = &udp_packet[UDP_srcport];
   cksum();
   udp_packet[UDP_cksum]= ~(hdr_chksum + ((hdr_chksum & 0xFFFF0000) >> 16));
      //echo the incoming data back to the VB program

	TxFID = get_free_TxFID();
	if(TxFID == 0)
	 rc = 1;
	else
	{
     rc = bap_write(TxFID,rxdatalength_offset,(char*)udp_packet,udp_packet[enetpacketLen11]+16);
	 if(rc=send_command(TransmitReclaim_Cmd,TxFID))
		printf("\r\nTransmit failed");
	 
     do_event_housekeeping();
	}
	return(rc);
 }
//******************************************************************
//*	UDP Function
//*   This function uses a Visual Basic UDP program to echo the
//*   data back to the VB program and set or reset PORT A bit 4
//*   under control of the VB program.
//******************************************************************
void udp()
{
	unsigned int temp;
	char rc;

   //port 7 is the well-known echo port
   if(packet[UDP_destport] == 0x0700)
   {
      //build the IP header
      setipaddrs();

      //swap the UDP source and destination ports
      temp = packet[UDP_srcport];
      packet[UDP_srcport] = packet[UDP_destport];
      packet[UDP_destport] = temp;

      //calculate the UDP checksum
      packet[UDP_cksum] = 0x00;

      hdr_chksum =0;
      hdrlen = 0x08;
      addr = &packet[ip_srcaddr];
      cksum();
      hdr_chksum = hdr_chksum + ((256*HIGH_BYTE(packet[ip_ttlproto]))+packet[UDP_len]);
      hdrlen = swapbytes(packet[UDP_len]);
      addr = &packet[UDP_srcport];
      cksum();
      packet[UDP_cksum]= ~(hdr_chksum + ((hdr_chksum & 0xFFFF0000) >> 16));
      //echo the incoming data back to the VB program
      rc = echo_packet();
   }

   //buttons on the VB GUI are pointed towards port address 5000 decimal
   else if(packet[UDP_destport] == 0x8813)
	  {
      if(packet[UDP_data] == '0')
         //received a "0" from the VB program
         LATA5=0;
      else if(packet[UDP_data] == '1')
         //received a "1" from the VB program
         LATA5=1;
      else if(packet[UDP_data] == 0x00)
         //received a 0x00 from the VB program
         LATA=0x00;
       else if(packet[UDP_data] == 0x01)
         //received a 0x01 from the VB program
         LATA1=1;
      else if(packet[UDP_data] == 0x02)
         //received a 0x02 from the VB program
         LATA2=1;
      else if(packet[UDP_data] == 0x03)
         //received a 0x03 from the VB program
         LATA3=1;
      else if(packet[UDP_data] == 0x04)
         //received a 0x04 from the VB program
		 LATA4=1;

     }
    

}
//******************************************************************
//*	TELNET SERVER BANNER STATEMENT CONSTANT
//******************************************************************
char const telnet_banner[] = "\r\nAirDrop-P>";
//******************************************************************
//*	Port Definitions
//*   This address is used by TCP and the Telnet function.
//*   This can be changed to any valid port number as long as
//*   you modify your code to recognize the new port number.
//******************************************************************
#define  MY_PORT_ADDRESS      0x981F  // 8088 DECIMAL
//******************************************************************
//*	Application Code
//*   Your application code goes here.
//******************************************************************
void application_code()
{
   char i,j,k;

   i=0;
   if(aux_data[i] == 0x0D && aux_data[i+1] == 0x0A)
   {
      tcpdatalen_out = 0x00;
      j = sizeof(telnet_banner);
	  tcpdatalen_out = j;         //length of the banner message
	  i=0;
	  k=0;
	  while(j > 1)
	  {
	   packet[TCP_data+k] = (telnet_banner[i+1] << 8) | telnet_banner[i];
		 i+=2;
		 ++k;
		 j-=2;
      }
	 while(j > 0)

	 {
	  packet[TCP_data+k] = telnet_banner[i];
	  --j;
	 }	  
   }
   else
      tcpdatalen_out = tcpdatalen_in;
}

//******************************************************************
//*	TCP Function
//*   This function uses TCP protocol to act as a Telnet server on
//*   port 8088 decimal.  The application function is called with
//*   every incoming character.
//******************************************************************
void tcp()
{
	char i,j,k;
	unsigned int temp;

   //assemble the destination port address from the incoming packet
   portaddr = packet[TCP_destport];

   //calculate the length of the data coming in with the packet
   tcpdatalen_in = (swapbytes(packet[ip_pktlen]))-((packet[ip_vers_len] & 0x0F) * 4)-(((packet[TCP_hdrflags] & 0x00FF) >> 4) * 4);

   //If an ACK is received and the destination port address is valid and no data is in the packet
   if(ACK_IN && portaddr == MY_PORT_ADDRESS && tcpdatalen_in == 0x00)
   {
      //assemble the acknowledgment number from the incoming packet
      incoming_ack =make32i(packet[TCP_acknum],packet[TCP_acknum+1]);

      //if the incoming packet is a result of session establishment
      if(bsynflag)
      {
         //clear the SYN flag
         clr_synflag;

         //the incoming acknowledgment is my new sequence number
         my_seqnum = incoming_ack;

         //send the Telnet server banner
         //limit the character count to 40 decimal
                j = sizeof(telnet_banner);
				tcpdatalen_out = j;         //length of the banner message
				i=0;
				k=0;
				do{
			       packet[TCP_data+k] = (telnet_banner[i+1] << 8) | telnet_banner[i];
				   i+=2;
				   ++k;
				  }while(j-- > 1);
			    do{
				   packet[TCP_data+k] = telnet_banner[i];
				  }while(j-- > 0);

         //expect to get an acknowledgment of the banner message
         expected_ack = my_seqnum + swapbytes(tcpdatalen_out);

         //send the TCP/IP packet
         send_tcp_packet();
      }
   }

   //if an ack is received and the port address is valid and there is data in the incoming packet
   if(ACK_IN && portaddr == MY_PORT_ADDRESS && tcpdatalen_in)
   {
      //receive the data and put it into the incoming data buffer
	  temp = tcpdatalen_in;
	  i=0;
      while(temp > 1)
	  {
	  	aux_data[i] = LOW_BYTE(packet[TCP_data+i]);
		aux_data[i+1] = HIGH_BYTE(packet[TCP_data+i]);
		i+=2;
		temp-=2;
	  }	
	  while(temp > 0)
	  {
	  	aux_data[i] = LOW_BYTE(packet[TCP_data+i]);
		--temp;
	  }	
         //run the TCP application
         application_code();

      //assemble the acknowledgment number from the incoming packet
      incoming_ack =make32i(packet[TCP_acknum],packet[TCP_acknum+1]);

      //check for the number of bytes acknowledged
      //determine how many bytes are outstanding and adjust the outgoing sequence number accordingly
      if(incoming_ack <= expected_ack)
         my_seqnum = expected_ack - (expected_ack - incoming_ack);

      //my expected acknowledgement number
      expected_ack = my_seqnum + swapbytes(tcpdatalen_out);


      send_tcp_packet();
   }

   //this code segment processes the incoming SYN from the Telnet client
   //and sends back the initial sequence number (ISN) and acknowledges
   //the incoming SYN packet
   if(SYN_IN && portaddr == MY_PORT_ADDRESS)
   {
      tcpdatalen_in = 0x01;
      set_synflag;

      setipaddrs();

      //swap the TCP source and destination ports
      temp = packet[TCP_srcport];
      packet[TCP_srcport] = packet[TCP_destport];
      packet[TCP_destport] = temp;

      //ASSEMBLE THE ACKNOWLEDGMENT
      client_seqnum=make32i(packet[TCP_seqnum],packet[TCP_seqnum+1]);
      client_seqnum = client_seqnum + swapbytes(tcpdatalen_in);
      packet[TCP_acknum] = (client_seqnum & 0xFFFF0000) >> 16;
      packet[TCP_acknum+1] = client_seqnum & 0x0000FFFF;

      if(++ISN == 0x0000 || ++ISN == 0xFFFF)
         ISN = 0x1234;
      my_seqnum = 0xFFFF3412;

      //PLACE THE ISN
	  packet[TCP_seqnum] = my_seqnum & 0x0000FFFF;
	  packet[TCP_seqnum+1] = (my_seqnum & 0xFFFF0000) >> 16;
	  //CLEAR TCP HEADER FLAGS
      packet[TCP_hdrflags] &= 0xC0FF;
      //SET THE SYN AND ACK FLAGS
      SYN_OUT;
      ACK_OUT;

      packet[TCP_cksum] = 0x00;
      //packet[TCP_cksum+1] = 0x00;

      hdr_chksum =0;
      hdrlen = 0x08;
      addr = &packet[ip_srcaddr];
      cksum();
      hdr_chksum = hdr_chksum + 256*HIGH_BYTE(packet[ip_ttlproto]);
      tcplen = swapbytes(packet[ip_pktlen]) - (LOW_BYTE(packet[ip_vers_len]) & 0x0F) *4;
      hdr_chksum = hdr_chksum + swapbytes(tcplen);
      hdrlen = tcplen;
      addr = &packet[TCP_srcport];
      cksum();
      packet[TCP_cksum]= ~(hdr_chksum + ((hdr_chksum & 0xFFFF0000) >> 16));
      echo_packet();
   }

   //this code segment processes a FIN from the Telnet client
   //and acknowledges the FIN and any incoming data.
   if(FIN_IN && portaddr == MY_PORT_ADDRESS)
   {
      if(tcpdatalen_in)
      {
         for(i=0;i<tcpdatalen_in;++i)
         {
            aux_data[i] = packet[TCP_data+i];
            application_code();
         }
      }

      set_finflag;

      ++tcpdatalen_in;

      incoming_ack =make32i(packet[TCP_acknum],packet[TCP_acknum+1]);
      if(incoming_ack <= expected_ack)
         my_seqnum = expected_ack - (expected_ack - incoming_ack);

      expected_ack = my_seqnum + swapbytes(tcpdatalen_out);
      send_tcp_packet();

   }
}
//******************************************************************
//*	Send TCP Packet
//*   This routine assembles and sends a complete TCP/IP packet.
//*   40 bytes of IP and TCP header data is assumed.
//******************************************************************
void send_tcp_packet()	
{
	unsigned int temp;

   //count IP and TCP header bytes.. Total = 40 bytes
   ip_packet_len = 40 + tcpdatalen_out;
   packet[ip_pktlen] = swapbytes(ip_packet_len);
   temp = packet[enetpacketLen11];  
   temp += tcpdatalen_out;	 
   packet[enetpacketLen11] = temp;  
   packet[enetpacketLen03] = swapbytes(temp);  

   setipaddrs();

      //swap the TCP source and destination ports
      temp = packet[TCP_srcport];
      packet[TCP_srcport] = packet[TCP_destport];
      packet[TCP_destport] = temp;

   client_seqnum=make32i(packet[TCP_seqnum],packet[TCP_seqnum+1]);
   client_seqnum = client_seqnum + swapbytes(tcpdatalen_in);
   packet[TCP_acknum] = (client_seqnum & 0xFFFF0000) >> 16;
   packet[TCP_acknum+1] = client_seqnum & 0x0000FFFF;
   packet[TCP_seqnum+1] = my_seqnum & 0x0000FFFF;
   packet[TCP_seqnum] = (my_seqnum & 0xFFFF0000) >> 16;



   packet[TCP_hdrflags] &= 0xC0FF;
   ACK_OUT;
   if(bfinflag)
   {
      FIN_OUT;
      clr_finflag;
   }

   packet[TCP_cksum] = 0x00;

   hdr_chksum =0;
   hdrlen = 0x08;
   addr = &packet[ip_srcaddr];
   cksum();
   hdr_chksum = hdr_chksum + 256*HIGH_BYTE(packet[ip_ttlproto]);
   tcplen = swapbytes(packet[ip_pktlen]) - (LOW_BYTE(packet[ip_vers_len]) & 0x0F) *4;
   hdr_chksum = hdr_chksum + swapbytes(tcplen);
   hdrlen = tcplen;
   addr = &packet[TCP_srcport];
   cksum();
   packet[TCP_cksum]= ~(hdr_chksum + ((hdr_chksum & 0xFFFF0000) >> 16));

	echo_packet();
}
//******************************************************************
//*	SETIPADDRS
//*   This function builds the IP header.
//******************************************************************
void setipaddrs(void)
{
   //move IP source address to destination address
   packet[ip_destaddr]=packet[ip_srcaddr];
   packet[ip_destaddr+1]=packet[ip_srcaddr+1];
   //make AirDrop module IP address source address
   packet[ip_srcaddr]=ipaddri[0];
   packet[ip_srcaddr+1]=ipaddri[1];
   //move hardware source address to destination address
   packet[enetpacketDest01]=packet[enetpacketSrc01];
   packet[enetpacketDest23]=packet[enetpacketSrc23];
   packet[enetpacketDest45]=packet[enetpacketSrc45];
   //make AirDrop module mac address the source address
   packet[enetpacketSrc01]=macaddri[0];
   packet[enetpacketSrc23]=macaddri[1];
   packet[enetpacketSrc45]=macaddri[2];

   //calculate the IP header checksum
   packet[ip_hdr_cksum]=0x00;

   hdr_chksum =0;
   hdrlen = (LOW_BYTE(packet[ip_vers_len]) & 0x0F) *4;
   addr = &packet[ip_vers_len];
   cksum();
   packet[ip_hdr_cksum]= ~(hdr_chksum + ((hdr_chksum & 0xFFFF0000) >> 16));
 }
//******************************************************************
//*	CHECKSUM CALCULATION ROUTINE
//******************************************************************
void cksum()
{
	  //hdr_chksum = 0;
      while(hdrlen > 1)
      {
	     hdr_chksum = hdr_chksum + *addr++;
         hdrlen -=2;
	  }
      if(hdrlen > 0)
	  {	
         hdr_chksum = hdr_chksum + (*addr & 0x00FF);
      	--hdrlen;
	  }		
}
//******************************************************************
//*	Echo Packet Function
//*   This routine does not modify the incoming packet size and
//*   thus echoes the original packet structure.
//******************************************************************
char echo_packet()
{
	char rc;
	unsigned int TxFID;

	TxFID = get_free_TxFID();
	if(TxFID == 0)
	 rc = 1;
	else
	{
     rc = bap_write(TxFID,rxdatalength_offset,(char*)packet,packet[enetpacketLen11]+16);
	 if(rc=send_command(TransmitReclaim_Cmd,TxFID))
		printf("\r\nTransmit failed");
	 
     do_event_housekeeping();
	}
	return(rc);
}
	
void wr_cf_data(char bapnum,char* buffer,unsigned int count)
{
	unsigned int addr,i;
	int *byteptr;
	char data_lo;

	if(bapnum)
		addr = Data1_Register;
	else
		addr = Data0_Register;

	byteptr = (int*)buffer;
	for(i=0;i<(count&0xFFFE);)
	{	
		wr_cf_io16(*byteptr++,addr); //write buffer word	
		i+=2;
	}
	if(count % 2)
	{
		data_lo = buffer[i++];		//write odd character if necessary
		wr_cf_io16(data_lo,addr);
	}
}
void wr_cf_addr(unsigned int addr)
{
	addr_hi = (make8(addr,1));
	addr_lo = addr & 0x00FF;
}

void wr_cf_reg(unsigned int reg_data,unsigned int reg_addr)
{
	TO_NIC;
	wr_cf_addr(reg_addr);
	data_out = reg_data;
	clr_WE;
	delay_ms(2);
	set_WE;
	FROM_NIC;
}
	
void wr_cf_io16(unsigned int data16,unsigned int addr)
{
	char i;

	wr_cf_addr(addr);
	data_out = LOW_BYTE(data16);
	TO_NIC;
	clr_IOWR;
	i=1;
	while(--i);
	set_IOWR;
	NOP();
	data_out = 0xFF;
	
	wr_cf_addr(addr+1);
	data_out = HIGH_BYTE(data16);
	clr_IOWR;
	i=1;
	while(--i);
	set_IOWR;
	NOP();
	data_out = 0xFF;
	FROM_NIC;
}
void wr_cf_io16s(unsigned int data16,unsigned int addr)
{
	wr_cf_addr(addr);
	data_out = LOW_BYTE(data16);
	TO_NIC;
	clr_IOWR;
	delay_ms(2);
	set_IOWR;
	NOP();
	data_out = 0xFF;
	
	wr_cf_addr(addr+1);
	data_out = HIGH_BYTE(data16);
	clr_IOWR;
	delay_ms(2);
	set_IOWR;
	NOP();
	data_out = 0xFF;
	FROM_NIC;
}

char rd_cf_reg(unsigned int reg_addr)
{
	char data,i;
	wr_cf_addr(reg_addr);
	clr_OE;
	i=1; 
	while(--i);			//read access delay
	data = data_in;
	set_OE;
	return(data);
}

unsigned int rd_cf_io16(unsigned int addr)
{
	char data_lo,data_hi,i;
	unsigned int data16;

	wr_cf_addr(addr);
	clr_IORD;
    i=3;
	while(--i);
	data_lo=data_in;
	set_IORD;
	NOP();

	wr_cf_addr(addr+1);
	clr_IORD;
    i=3;
	while(--i);
	data_hi=data_in;
	set_IORD;
	NOP();
	data16 = make16(data_hi,data_lo);
	return(data16);
}
unsigned int rd_cf_io16s(unsigned int addr)
{
	char data_lo,data_hi;
	unsigned int data16;

	wr_cf_addr(addr);
	clr_IORD;
	delay_ms(2); 			// 1 back to 2
	data_lo=data_in;
	set_IORD;
	NOP();

	wr_cf_addr(addr+1);
	clr_IORD;
	delay_ms(2);
	data_hi=data_in;
	set_IORD;
	NOP();
	data16 = make16(data_hi,data_lo);
	return(data16);
}

char  send_command(unsigned int cmd, unsigned int parm0)
{
	char cmd_code,rc;
	unsigned int cmd_status,evstat_data;

	do{
	   cmd_data = rd_cf_io16(Command_Register);
	  }while(cmd_data &  CmdBusy_Bit_Mask);
	
	wr_cf_io16(parm0, Param0_Register);
	wr_cf_io16(cmd, Command_Register);
	
	do{
	   cmd_data = rd_cf_io16(Command_Register);
	  }while(cmd_data &  CmdBusy_Bit_Mask);
	
	do{
		evstat_data = rd_cf_io16(EvStat_Register);
	  }while(!(evstat_data & EvStat_Cmd_Bit_Mask));

	cmd_status = rd_cf_io16( Status_Register);
	rc = cmd_status &  Status_Result_Mask;
	wr_cf_io16( EvStat_Cmd_Bit_Mask, EvAck_Register);

	switch(rc)
	{
		case 0x00:
			rc = 0;	//command completed OK
			break;
		case 0x01:
			rc = 1;	//card failure
			break;
		case 0x05:
			rc = 2; //no buffer space
			break;
		case 0x7F:
			rc = 3; //command error
			break;
	}
	return(rc);
}
void create_comframestructure(unsigned int len)
{
	unsigned int i;
    
	for(i=0;i<len;++i)
	 comframe_buffer[i] = 0x00;

	comframe_buffer[12] = 0x04;
    comframe_buffer[13] = 0x00;
	if(ad802_11Header)
	{
	comframe_buffer[14] = 0x08;
	comframe_buffer[15] = 0x01;
	}
	else
	{
	for(i=0;i<6;++i)
	 comframe_buffer[txsourceaddr_offset+i] = macaddrc[i];
	}
	//printf("\r\nTransmit Communications Frame Structure created and initialized ...");
	//for (i=0; i<len; i++, i++)
   //{
	//	printf("\r\n%02X) Read (High Low): %02X %02X", i, comframe_buffer[i+1], comframe_buffer[i]);
	//	if (i==12 || i==44 || i==58)
	//		printf("\r\n");
	//}

}
char allocate_buffer(unsigned int bufferlen)
{
	char rc;

	rc = send_command(Allocate_Cmd, bufferlen);
	//if (rc)
	//	printf("\r\nFID Buffer Allocate command failed with %02X", rc);
	//else
	//	printf("\r\nFID Buffer Allocate command successful");
	return rc;
}
char allocate_xmit_buffers(void)
{
	unsigned int TxFID,buffstoalloc,evstat_data;
	char i,rc;

    buffstoalloc = 3;
    for(i=0;i<3;++i)
	 TxFID_buffers[i] = 0;
	free_TxFIDs = 0; 
	create_comframestructure(framestructure_size+ethheader_size);
	for (i=0; i<3; i++)
   {
		rc = allocate_buffer(txframe_buffer_size);	// Ask for a buffer
		if (rc)
      {
			printf("\r\nError (%02X) - could not allocate %u-byte buffer", rc, txframe_buffer_size);
			return 1;
		}
	do{
		evstat_data = rd_cf_io16(EvStat_Register);
	  }while(!(evstat_data & EvStat_Alloc_Bit_Mask));

     TxFID = rd_cf_io16(AllocFID_Register);	// Get the FID of the allocated buffer
     wr_cf_io16(EvStat_Alloc_Bit_Mask,EvAck_Register );	// Acknowledge we own the FID
     //printf("\r\nSuccessfully pre-allocated transmit data frame buffer %u (%u of %u), FID: %04X", i, i+1, buffstoalloc, TxFID);

     rc = bap_write(TxFID,0x0000,comframe_buffer, framestructure_size+ethheader_size);

      // Write the frame structure header (including the unused 802.11 style header, but not the 802.3 header)
	  if (rc)
       printf("\r\nCreate TxFrameStructure WriteBAP failed with return code: %02X", rc);

		TxFID_buffers[i] = TxFID;		// Remember the FID
		bitset(free_TxFIDs, i);			// Mark this FID available to us
	}
	return 0;
}

unsigned int get_free_TxFID(void)
{
	unsigned int TxFID;

	TxFID = 0x0000;
	if(free_TxFIDs & 0x01)
	{
	  bitclr(free_TxFIDs,0);
	  TxFID = TxFID_buffers[0];
	}
	else if(free_TxFIDs & 0x02)
	{
	  bitclr(free_TxFIDs,1);
	  TxFID = TxFID_buffers[1];
	}
	else if(free_TxFIDs & 0x04)
	{
	  bitclr(free_TxFIDs,2);
	  TxFID = TxFID_buffers[2];
	}

	  return(TxFID);
}
void init_cf_card(void)
{
	char cor_addr_lo,cor_addr_hi,cor_data;
	char cis_device;
    unsigned int x,index,junk;
	unsigned int cis_addr;  // attribute memory index (EVEN ADDRS ONLY)
	char code_tuple;		// tuple type
    char link_tuple;        // number of bytes in tuple structure
    char tuple_link_cnt;	// tuple byte count
	char tuple_data;		// current tuple contents
    char funce_cnt;      	 	
    char mac_cnt;
	char rc;

	set_RSET;				//reset CF card
	SETUP_A;				//configure I/O ports
	SETUP_C;
	SETUP_E;
	SETUP_F;
	SETUP_G;
	FROM_NIC;				//set to receive from NIC
	clr_RSET;				//take CF card out of reset
	clrf_cis;				//clear cis flag
	rc = 0;					//clear result code
	i = 500;				//wait for cis functionality to come up
	do{
	 delay_ms(2);
	 if(--i == 0)
	 {
	  rc = 1;
	  break;
	 }
	 code_tuple = rd_code_tuple(0x0000);	
	 if(code_tuple == 1)	//1 denotes the Device Tuple
	  setf_cis;		
	}while(!(bcisflag));
	if(rc)
	{
	 printf("\r\nCIS Entry Failed..");
	 printf("\r\nDriver Halted..");
	 while(1);
	}
   cis_device  = 0;
   cor_addr    = 0;
   funce_cnt = 0;			// reset to the first CF_CISTPL_FUNCE
   mac_cnt   = 0;
   cis_addr   = 0;			// CIS starts at location 0 of Attribute memory
   clrf_cis;
   index = 0;
	do{
   		code_tuple = rd_code_tuple(cis_addr);	//read code tuple
		tple_data[index++] = code_tuple;
        cis_addr+=2;							//increment addr to link tuple

        link_tuple = rd_link_tuple(cis_addr);	//read link tuple
		tple_data[index++] = link_tuple;
        cis_addr+=2;  							//increment addr to data tuple
    
	  if(code_tuple != END_TUPLE)
      {
       for(tuple_link_cnt=0;tuple_link_cnt<link_tuple;++tuple_link_cnt)		
       {
      	 tuple_data = rd_tuple_data(cis_addr);	//read tuple data bytes
         cis_addr+=2;

          switch(code_tuple)	
          {
          	 case DEVICE_TUPLE:			
		      //printf("\r\nDEVICE_TUPLE %02X = %02X",tuple_link_cnt,tuple_data); 
		      break;	
             case DEVICE_A_TUPLE:
		      //printf("\r\nDEVICE_A_TUPLE %02X = %02X",tuple_link_cnt,tuple_data); 
		      break;	
             case DEVICE_OC_TUPLE:		
		      //printf("\r\nDEVICE_OC_TUPLE %02X = %02X",tuple_link_cnt,tuple_data); 
		      break;	
             case DEVICE_OA_TUPLE:  		
		      //printf("\r\nDEVICE_OA_TUPLE %02X = %02X",tuple_link_cnt,tuple_data); 
		      break;	
             case VERS_1_TUPLE:     		
		      //printf("\r\nVERS_1_TUPLE %02X = %c",tuple_link_cnt,tuple_data); 
		      break;	
             case MANFID_TUPLE:     		
		      //printf("\r\nMANFID_TUPLE %02X = %02X",tuple_link_cnt,tuple_data); 
		      break;	
             case FUNCID_TUPLE:	
		      //printf("\r\nFUNCID_TUPLE %02X = %02X",tuple_link_cnt,tuple_data); 
              if(tuple_link_cnt == 0)
			   cis_device = tuple_data; 	// device type 0x06 is Network Adapter
			  break;
             case FUNCE_TUPLE: 			// GET THE MAC ADDRESS
		      //printf("\r\nFUNCE_TUPLE %02X = %02X",tuple_link_cnt,tuple_data); 
               if(funce_cnt == 4) 		// funce[4] holds the MAC address
               	if(tuple_link_cnt>1)			// MAC is body [2..7] in funce[4]
                  	macaddrc[mac_cnt++] = tuple_data; // store the MAC
               if(tuple_link_cnt == (link_tuple-1))	// we are done with the data for this funce
               	  funce_cnt++;        		// increment to indicate the next funce tuple
              break;
             case CONFIG_TUPLE:			// GET THE COR ADDRESS
		      //printf("\r\nCONFIG_TUPLE %02X = %02X",tuple_link_cnt,tuple_data); 
               if(tuple_link_cnt == 2)
               	cor_addr_lo = tuple_data;		  	// copying low-byte
               if(tuple_link_cnt == 3)              // shift, then copy hi-byte
			   {
               	cor_addr_hi = tuple_data;
				cor_addr = make16(cor_addr_hi,cor_addr_lo);
			   }
              break;
             case CFTABLE_ENTRY_TUPLE:	
		      //printf("\r\nCFTABLE_ENTRY_TUPLE %02X = %02X",tuple_link_cnt,tuple_data); 
		      break;	
             default:					
	          break;
          }// end switch

       }// end for loop tuple_link_cnt
     }//if(code_tuple != END_TUPLE)
      else
	  {
		setf_cis;
	  }
   	}while(!(bcisflag));
    //cor_addr = 0x03E0;
   	cor_data = rd_cor_data(cor_addr);		//get the current bit mask
	delay_ms(4);
	cor_data |= io_en_mask;					//add I/O enable bit
	wr_cor_data(cor_data,cor_addr);			//write the modified bit mask
	rc =  send_command( Initialize_Cmd, 0);
	switch(rc)
	{
		case 0:	
		    printf("\r\n\r\nNERDVILLA Temperature/Humidity Monitor Initialized");
	        break;
		case 1:
			printf("\r\nAirDrop-P Initialization Failure");
			break;
		case 2:
			printf("\r\nNo buffer space");
			break;
		case 3:
			printf("\r\nCommand error");
			break;
		default:
			printf("\r\nResult Code = %x",rc);
			break;
	}
}

void show_time(void)
{
	 printf("%c[2;36H %02d:%02d:%02d",esc,hours,mins,secs);
}
//**************************************************************
//*  void cls(void)
//*  Clear terminal window
//**************************************************************
void cls(void)
{
   printf("%c[2J",esc);
}
//**************************************************************
//*  void get_octet(void)
//*  get ip octet
//**************************************************************
void get_octet(void)
{

			 i = 0;
			chr_count = 0;

			 do
			 {
			 	while(!(CharInQueue()));
          	 	bytein = recvchar();
		  	    if(bytein > 0x2F && bytein < 0x3A && chr_count < 3)
				{
					ipentry[i++] = bytein;
				    sendchar(bytein);
				}
			 		++chr_count;

			 }while(bytein != 0x2E  && bytein != 0x0D);
			 if(bytein == 0x2E)
			 	sendchar(bytein);

			 switch(chr_count-1)
			 {
				case 1:
					ipentry[chr_1] = ipentry[chr_3];
					ipentry[chr_3] = 0x30;
					ipentry[chr_2] = 0x30;
				break;
				case 2:
					ipentry[chr_1] = ipentry[chr_2];
					ipentry[chr_2] = ipentry[chr_3];
					ipentry[chr_3] = 0x30;
				break;
				default:
				break;
			}
}

void menu(void)
{
		  char j;
	      char temp[4];

		   for(eeaddr = 0;eeaddr < 0x09;++eeaddr)
			{
			 while(WR);
		   	 EEADRH = 0x00;
		     EEADR = eeaddr;
			 EEDATA = parameters[eeaddr];	
			 EECON1 &= 0x3F;
		     RD = 1;
			 parameters[eeaddr] = EEDATA;
			}
		
		ipaddrc[0] = parameters[0];	
		ipaddrc[1] = parameters[1];	
		ipaddrc[2] = parameters[2];	
		ipaddrc[3] = parameters[3];	
		remoteipaddrc[0] = parameters[4];
		remoteipaddrc[1] = parameters[5];
		remoteipaddrc[2] = parameters[6];
		remoteipaddrc[3] = parameters[7];
		 
		   j = 0;
		   for(eeaddr = 0x09;eeaddr < 0x0D;++eeaddr)
			{
			 while(WR);
		   	 EEADRH = 0x00;
		     EEADR = eeaddr;
			 EEDATA = temp[j];	
			 EECON1 &= 0x3F;
		     RD = 1;
			 temp[j++] = EEDATA;
			}
		 udpaddrs[local_udpaddr] = make32(temp[0],temp[1],temp[2],temp[3]);

		   j = 0;
		   for(eeaddr = 0x0D;eeaddr < 0x11;++eeaddr)
			{
			 while(WR);
		   	 EEADRH = 0x00;
		     EEADR = eeaddr;
			 EEDATA = temp[j];	
			 EECON1 &= 0x3F;
		     RD = 1;
			 temp[j++] = EEDATA;
			}
		 udpaddrs[remote_udpaddr] = make32(temp[0],temp[1],temp[2],temp[3]);
	    		
		
   	   printf("%c[2J",esc);
   	   printf("%c[1;18H    NERDVILLA TEMP/HUMIDITY SENSOR Ver 6.18.06",esc);
  	   printf("%c[4;25H C   CYCLE TIME (MINUTES)",esc);
  	   printf("%c[4;50H - %d",esc,parameters[loopsecs]);
	   printf("%c[5;25H S   SENSOR IP ADDRESS",esc);
  	   printf("%c[5;50H - %d.%d.%d.%d",esc,parameters[local_ipaddr3],parameters[local_ipaddr2],parameters[local_ipaddr1],parameters[local_ipaddr0]);
	   printf("%c[6;25H H   HOST IP ADDRESS",esc);
  	   printf("%c[6;50H - %d.%d.%d.%d",esc,parameters[host_ipaddr3],parameters[host_ipaddr2],parameters[host_ipaddr1],parameters[host_ipaddr0]);
	   printf("%c[7;25H L   SENSOR UDP PORT",esc);
  	   printf("%c[7;50H - %ld",esc,udpaddrs[local_udpaddr]);
	   printf("%c[8;25H R   HOST UDP PORT",esc);
  	   printf("%c[8;50H - %ld",esc,udpaddrs[remote_udpaddr]);

	   printf("%c[10;25H PRESS ESC TO RUN",esc);

}
void enter_parms(void)
{
	unsigned int i,tenthousands,thousands,hundreds, tens, ones;
	 char j;
do{
	 secs = 0x00;
	 do{
		++i;
   	 }while(!(CharInQueue()) && secs != 0x0A);
	if(CharInQueue())
	 bytein = recvchar();
	else
	 bytein = esc;

    switch(toupper(bytein))
    {

        case 'C':
			TMR1ON = 0;
			do{
			 clr_entryflag;
		   	 parameters[loopsecs] = 0;
		   	 cls();
   		     printf("%c[10;25H MEASUREMENT CYCLE TIME (001-100) ",esc);
	       	 while(!(CharInQueue()));
          	 hundreds = recvchar();
			 sendchar(hundreds);
	       	 while(!(CharInQueue()));
          	 tens = recvchar();
			 sendchar(tens);
	       	 while(!(CharInQueue()));
          	 ones = recvchar();
			 sendchar(ones);
		  	 if(hundreds > 0x2F  && hundreds <= 0x31 && tens > 0x2F  && tens < 0x3A && ones > 0x2F  && ones < 0x3A)
			 {
			  hundreds -= 0x30;
		  	  hundreds *= 100;
		      parameters[loopsecs] = parameters[loopsecs] + hundreds;
		  	  tens -= 0x30;
		  	  tens *= 10;
		      parameters[loopsecs] = parameters[loopsecs] + tens;
              ones -= 0x30;
		      parameters[loopsecs] = parameters[loopsecs] + ones;

			  if(parameters[loopsecs] > 100 || parameters[loopsecs] < 1)
			  	clr_entryflag;
			  else
				set_entryflag;
			  }
		  	}while(!(bentryflag));

           disable_GLOBALint;	
			 while(WR);
		   	 EEADRH = 0x00;
		     EEADR = loopsecs;
			 EEDATA = parameters[loopsecs];	
			 EECON1 &= 0x3F;
		     WREN = 1;
			 EECON2 = 0x55;
			 EECON2 = 0xAA;
		     WR = 1;
             WREN = 0;
			 EEIF = 0;
		     enable_GLOBALint;	
		  
		  secs = 0;
		  TMR1ON = 1;		
		  
		  menu();
          break;

         case 'S':
				TMR1ON = 0;
			 	clr_entryflag;
			 	for(i=local_ipaddr;i<host_ipaddr;++i)
		     		parameters[i] = 0x00;
		   	 	cls();
   		   		printf("%c[10;15H ENTER SENSOR IP ADDRESS (xxx.xxx.xxx.xxx) ",esc);
				do{
					get_octet();
			  		ipentry[chr_3] -= 0x30;
		  	  		ipentry[chr_3] *= 100;
		      		parameters[local_ipaddr3] += ipentry[chr_3];
			  		ipentry[chr_2] -= 0x30;
		  	  		ipentry[chr_2] *= 10;
		      		parameters[local_ipaddr3] += ipentry[chr_2];
			  		ipentry[chr_1] -= 0x30;
		      		parameters[local_ipaddr3] += ipentry[chr_1];

			  		if(parameters[local_ipaddr3] > 255 || parameters[local_ipaddr3] <= 0)
					{
			 			clr_entryflag;
			 			for(i=0;i<4;++i)
		     		 	 parameters[i] = 0x00;
		   	 			cls();
   		   				printf("%c[10;15H ENTER SENSOR IP ADDRESS (xxx.xxx.xxx.xxx) ",esc);
					}
			  else
			    set_entryflag;
		  	}while(!(bentryflag));

				clr_entryflag;	
				do{
					get_octet();
			  		ipentry[chr_3] -= 0x30;
		  	  		ipentry[chr_3] *= 100;
		      		parameters[local_ipaddr2] += ipentry[chr_3];
			  		ipentry[chr_2] -= 0x30;
		  	  		ipentry[chr_2] *= 10;
		      		parameters[local_ipaddr2] += ipentry[chr_2];
			  		ipentry[chr_1] -= 0x30;
		      		parameters[local_ipaddr2] += ipentry[chr_1];

			  		if(parameters[local_ipaddr2] > 255 || parameters[local_ipaddr2] < 0)
					{
			 			clr_entryflag;
			 			for(i=1;i<4;++i)
		     		 	 parameters[i] = 0x00;
		   	 			cls();
		   	 			printf("%c[10;15H ENTER SENSOR IP ADDRESS (xxx.xxx.xxx.xxx) %d.",esc,parameters[local_ipaddr3]);
					}
			  else
			    set_entryflag;
		  	}while(!(bentryflag));	

				clr_entryflag;	
				do{
					get_octet();
			  		ipentry[chr_3] -= 0x30;
		  	  		ipentry[chr_3] *= 100;
		      		parameters[local_ipaddr1] += ipentry[chr_3];
			  		ipentry[chr_2] -= 0x30;
		  	  		ipentry[chr_2] *= 10;
		      		parameters[local_ipaddr1] += ipentry[chr_2];
			  		ipentry[chr_1] -= 0x30;
		      		parameters[local_ipaddr1] += ipentry[chr_1];

			  		if(parameters[local_ipaddr1] > 255 || parameters[local_ipaddr1] < 0)
					{
			 			clr_entryflag;
			 			for(i=2;i<4;++i)
		     		 	 parameters[i] = 0x00;
		   	 			cls();
		   	 			printf("%c[10;15H ENTER SENSOR IP ADDRESS (xxx.xxx.xxx.xxx) %d.%d.",esc,parameters[local_ipaddr3],parameters[local_ipaddr2]);
					}
			  else
			    set_entryflag;
		  	}while(!(bentryflag));	

				clr_entryflag;	
				do{
					get_octet();
			  		ipentry[chr_3] -= 0x30;
		  	  		ipentry[chr_3] *= 100;
		      		parameters[local_ipaddr0] += ipentry[chr_3];
			  		ipentry[chr_2] -= 0x30;
		  	  		ipentry[chr_2] *= 10;
		      		parameters[local_ipaddr0] += ipentry[chr_2];
			  		ipentry[chr_1] -= 0x30;
		      		parameters[local_ipaddr0] += ipentry[chr_1];

			  		if(parameters[local_ipaddr0] > 255 || parameters[local_ipaddr0] < 0)
					{
			 			clr_entryflag;
			 			for(i=3;i<4;++i)
		     		 	 parameters[i] = 0x00;
		   	 			cls();
		   	 			printf("%c[10;15H ENTER SENSOR IP ADDRESS (xxx.xxx.xxx.xxx) %d.%d.%d.",esc,parameters[local_ipaddr3],parameters[local_ipaddr2],parameters[local_ipaddr1]);
					}
			  else
			    set_entryflag;
		  	}while(!(bentryflag));
	
           disable_GLOBALint;	
		   for(eeaddr = local_ipaddr;eeaddr < host_ipaddr;++eeaddr)
			{
			 while(WR);
		   	 EEADRH = 0x00;
		     EEADR = eeaddr;
			 EEDATA = parameters[eeaddr];	
			 EECON1 &= 0x3F;
		     WREN = 1;
			 EECON2 = 0x55;
			 EECON2 = 0xAA;
		     WR = 1;
             WREN = 0;
			 EEIF = 0;
			}
			enable_GLOBALint;	
		  secs = 0;
		  TMR1ON = 1;		

			menu();

	     break;
         case 'H':
			    TMR1ON = 0;
			 	clr_entryflag;
			 	for(i=host_ipaddr;i<loopsecs;++i)
		     		parameters[i] = 0x00;
		   	 	cls();
   		   		printf("%c[10;15H ENTER HOST IP ADDRESS (xxx.xxx.xxx.xxx) ",esc);
				do{
					get_octet();
			  		ipentry[chr_3] -= 0x30;
		  	  		ipentry[chr_3] *= 100;
		      		parameters[host_ipaddr3] += ipentry[chr_3];
			  		ipentry[chr_2] -= 0x30;
		  	  		ipentry[chr_2] *= 10;
		      		parameters[host_ipaddr3] += ipentry[chr_2];
			  		ipentry[chr_1] -= 0x30;
		      		parameters[host_ipaddr3] += ipentry[chr_1];

			  		if(parameters[host_ipaddr3] > 255 || parameters[host_ipaddr3] <= 0)
					{
			 			clr_entryflag;
			 			for(i=host_ipaddr;i<loopsecs;++i)
		     		 	 parameters[i] = 0x00;
		   	 			cls();
   		   				printf("%c[10;15H ENTER HOST IP ADDRESS (xxx.xxx.xxx.xxx) ",esc);
					}
			  else
			    set_entryflag;
		  	}while(!(bentryflag));

				clr_entryflag;	
				do{
					get_octet();
			  		ipentry[chr_3] -= 0x30;
		  	  		ipentry[chr_3] *= 100;
		      		parameters[host_ipaddr2] += ipentry[chr_3];
			  		ipentry[chr_2] -= 0x30;
		  	  		ipentry[chr_2] *= 10;
		      		parameters[host_ipaddr2] += ipentry[chr_2];
			  		ipentry[chr_1] -= 0x30;
		      		parameters[host_ipaddr2] += ipentry[chr_1];

			  		if(parameters[host_ipaddr2] > 255 || parameters[host_ipaddr2] < 0)
					{
			 			clr_entryflag;
			 			for(i=host_ipaddr2;i<loopsecs;++i)
		     		 	 parameters[i] = 0x00;
		   	 			cls();
		   	 			printf("%c[10;15H ENTER HOST IP ADDRESS (xxx.xxx.xxx.xxx) %d.",esc,parameters[host_ipaddr3]);
					}
			  else
			    set_entryflag;
		  	}while(!(bentryflag));	

				clr_entryflag;	
				do{
					get_octet();
			  		ipentry[chr_3] -= 0x30;
		  	  		ipentry[chr_3] *= 100;
		      		parameters[host_ipaddr1] += ipentry[chr_3];
			  		ipentry[chr_2] -= 0x30;
		  	  		ipentry[chr_2] *= 10;
		      		parameters[host_ipaddr1] += ipentry[chr_2];
			  		ipentry[chr_1] -= 0x30;
		      		parameters[host_ipaddr1] += ipentry[chr_1];

			  		if(parameters[host_ipaddr1] > 255 || parameters[host_ipaddr1] < 0)
					{
			 			clr_entryflag;
			 			for(i=host_ipaddr1;i<loopsecs;++i)
		     		 	 parameters[i] = 0x00;
		   	 			cls();
		   	 			printf("%c[10;15H ENTER HOST IP ADDRESS (xxx.xxx.xxx.xxx) %d.%d.",esc,parameters[host_ipaddr3],parameters[host_ipaddr2]);
					}
			  else
			    set_entryflag;
		  	}while(!(bentryflag));	

				clr_entryflag;	
				do{
					get_octet();
			  		ipentry[chr_3] -= 0x30;
		  	  		ipentry[chr_3] *= 100;
		      		parameters[host_ipaddr0] += ipentry[chr_3];
			  		ipentry[chr_2] -= 0x30;
		  	  		ipentry[chr_2] *= 10;
		      		parameters[host_ipaddr0] += ipentry[chr_2];
			  		ipentry[chr_1] -= 0x30;
		      		parameters[host_ipaddr0] += ipentry[chr_1];

			  		if(parameters[host_ipaddr0] > 255 || parameters[host_ipaddr0] < 0)
					{
			 			clr_entryflag;
			 			for(i=host_ipaddr0;i<loopsecs;++i)
		     		 	 parameters[i] = 0x00;
		   	 			cls();
		   	 			printf("%c[10;15H ENTER HOST IP ADDRESS (xxx.xxx.xxx.xxx) %d.%d.%d.",esc,parameters[host_ipaddr3],parameters[host_ipaddr2],parameters[host_ipaddr1]);
					}
			  else
			    set_entryflag;
		  	}while(!(bentryflag));

           disable_GLOBALint;	
		   for(eeaddr = host_ipaddr;eeaddr < loopsecs;++eeaddr)
			{
			 while(WR);
		   	 EEADRH = 0x00;
		     EEADR = eeaddr;
			 EEDATA = parameters[eeaddr];	
			 EECON1 &= 0x3F;
		     WREN = 1;
			 EECON2 = 0x55;
			 EECON2 = 0xAA;
		     WR = 1;
             WREN = 0;
			 EEIF = 0;
			}
			enable_GLOBALint;	
		  secs = 0;
		  TMR1ON = 1;		

			menu();

	     break;
        case 'L':
			TMR1ON = 0;
			do{
			 clr_entryflag;
		   	 udpaddrs[local_udpaddr] = 0;
		   	 cls();
   		     printf("%c[10;25H ENTER SENSOR UDP PORT NUMBER (00001-65535) ",esc);
	       	 while(!(CharInQueue()));
          	 tenthousands = recvchar();
			 sendchar(tenthousands);
	       	 while(!(CharInQueue()));
          	 thousands = recvchar();
			 sendchar(thousands);
	       	 while(!(CharInQueue()));
          	 hundreds = recvchar();
			 sendchar(hundreds);
	       	 while(!(CharInQueue()));
          	 tens = recvchar();
			 sendchar(tens);
	       	 while(!(CharInQueue()));
          	 ones = recvchar();
			 sendchar(ones);
		  	 if(tenthousands > 0x2F  && tenthousands <= 0x36 && thousands > 0x2F  && thousands < 0x3A && hundreds > 0x2F  && hundreds < 0x3A && tens > 0x2F  && tens < 0x3A && ones > 0x2F  && ones < 0x3A)
			 {
		      tenthousands -= 0x30;
		      udpaddrs[local_udpaddr] = udpaddrs[local_udpaddr] + (tenthousands * 10000);
		      thousands -= 0x30;
		      udpaddrs[local_udpaddr] = udpaddrs[local_udpaddr] + (thousands * 1000);
			  hundreds -= 0x30;
		      udpaddrs[local_udpaddr] = udpaddrs[local_udpaddr] + (hundreds * 100);
		  	  tens -= 0x30;
		  	  tens *= 10;
		      udpaddrs[local_udpaddr] = udpaddrs[local_udpaddr] + tens;
              ones -= 0x30;
		      udpaddrs[local_udpaddr] = udpaddrs[local_udpaddr] + ones;

			  if(udpaddrs[local_udpaddr] > 65535 || udpaddrs[local_udpaddr] < 1)
			  	clr_entryflag;
			  else
				set_entryflag;
			  }
		  	}while(!(bentryflag));

           disable_GLOBALint;
			j = 0x03;
			for(i=0;i<4;++i)
			{	
			 while(WR);
		   	 EEADRH = 0x00;
		     EEADR = local_udpaddr + 9 + i;
			 EEDATA = make8(udpaddrs[local_udpaddr],j--);	
			 EECON1 &= 0x3F;
		     WREN = 1;
			 EECON2 = 0x55;
			 EECON2 = 0xAA;
		     WR = 1;
             WREN = 0;
			 EEIF = 0;
			}

		     enable_GLOBALint;	
		  
		  secs = 0;
		  TMR1ON = 1;		
		  
		  menu();
          break;
        case 'R':
			TMR1ON = 0;
			do{
			 clr_entryflag;
		   	 udpaddrs[remote_udpaddr] = 0;
		   	 cls();
   		     printf("%c[10;25H ENTER HOST UDP PORT NUMBER (00001-65535) ",esc);
	       	 while(!(CharInQueue()));
          	 tenthousands = recvchar();
			 sendchar(tenthousands);
	       	 while(!(CharInQueue()));
          	 thousands = recvchar();
			 sendchar(thousands);
	       	 while(!(CharInQueue()));
          	 hundreds = recvchar();
			 sendchar(hundreds);
	       	 while(!(CharInQueue()));
          	 tens = recvchar();
			 sendchar(tens);
	       	 while(!(CharInQueue()));
          	 ones = recvchar();
			 sendchar(ones);
		  	 if(tenthousands > 0x2F  && tenthousands <= 0x36 && thousands > 0x2F  && thousands <0x3A && hundreds > 0x2F  && hundreds < 0x3A && tens > 0x2F  && tens < 0x3A && ones > 0x2F  && ones < 0x3A)
			 {
		      tenthousands -= 0x30;
		      udpaddrs[remote_udpaddr] = udpaddrs[remote_udpaddr] + (tenthousands * 10000);
		      thousands -= 0x30;
		      udpaddrs[remote_udpaddr] = udpaddrs[remote_udpaddr] + (thousands * 1000);
			  hundreds -= 0x30;
		      udpaddrs[remote_udpaddr] = udpaddrs[remote_udpaddr] + (hundreds * 100);
		  	  tens -= 0x30;
		  	  tens *= 10;
		      udpaddrs[remote_udpaddr] = udpaddrs[remote_udpaddr] + tens;
              ones -= 0x30;
		      udpaddrs[remote_udpaddr] = udpaddrs[remote_udpaddr] + ones;

			  if(udpaddrs[remote_udpaddr] > 65535 || udpaddrs[remote_udpaddr] < 1)
			  	clr_entryflag;
			  else
				set_entryflag;
			  }
		  	}while(!(bentryflag));

           disable_GLOBALint;
	        j = 0x03;	
			for(i=0;i<4;++i)
			{	
			 while(WR);
		   	 EEADRH = 0x00;
		     EEADR = remote_udpaddr + 12 + i;
			 EEDATA = make8(udpaddrs[remote_udpaddr],j--);	
			 EECON1 &= 0x3F;
		     WREN = 1;
			 EECON2 = 0x55;
			 EECON2 = 0xAA;
		     WR = 1;
             WREN = 0;
			 EEIF = 0;
			}

			enable_GLOBALint;	
		  
		  secs = 0;
		  TMR1ON = 1;		
		  
		  menu();
          break;
	    default:
		break;

    }
   }while(bytein != esc);
}
//******************************************************************
//*	SENSOR DRIVERS
//******************************************************************
//******************************************************************
//*	writes a byte on the Sensibus and checks the acknowledge 
//******************************************************************
char sht_write_byte(char value)
{ 
  char i;
  error=0;  
  TO_SENSOR;
  for (i=0x80;i>0;i/=2)             //shift bit for masking
  { 
   if (i & value) 
     DATA = 1;
    else DATA=0;                        
    SCK=1;                          //clk for SENSI-BUS
    delay_ms(1);        //pulswith approx. 5 us  	
    SCK=0;
    delay_ms(1);        //pulswith approx. 5 us  	
  }
  FROM_SENSOR;
  SCK=1;                            //clk #9 for ack 
  delay_ms(1);
  error=DATA_IN;                       //check ack (DATA will be pulled down by SHT11)
  SCK=0; 
  delay_ms(1);       
  return error;                     //error=1 in case of no acknowledge
}

//----------------------------------------------------------------------------------
char sht_read_byte(char ack)
//----------------------------------------------------------------------------------
// reads a byte form the Sensibus and gives an acknowledge in case of "ack=1" 
{ 
  char i,val=0;
  FROM_SENSOR;
  for (i=0x80;i>0;i/=2)             //shift bit for masking
  { 
    SCK=1;                          //clk for SENSI-BUS
    delay_ms(1);
    if (DATA_IN) 
	 val=(val | i);        //read bit  
    SCK=0; 
    delay_ms(1); 					 
  }
  TO_SENSOR;
  DATA=!ack;                        //in case of "ack==1" pull down DATA-Line
  SCK=1;                            //clk #9 for ack
  delay_ms(1);          //pulswith approx. 5 us 
  SCK=0;
  delay_ms(1);
  FROM_SENSOR;						    
  return val;
}

//----------------------------------------------------------------------------------
void sht_xmit_start(void)
//----------------------------------------------------------------------------------
// generates a transmission start 
//       _____         ________
// DATA:      |_______|
//           ___     ___
// SCK : ___|   |___|   |______
{  
   TO_SENSOR;
   DATA=1; 
   SCK=0;                   
   delay_ms(1);
   SCK=1;
   delay_ms(1);
   DATA=0;
   delay_ms(1);
   SCK=0;  
   delay_ms(1);	
   SCK=1;
   delay_ms(1);
   DATA=1;		   
   delay_ms(1);
   SCK=0;
   delay_ms(1);		   
}

//----------------------------------------------------------------------------------
void sht_connectionreset(void)
//----------------------------------------------------------------------------------
// communication reset: DATA-line=1 and at least 9 SCK cycles followed by transstart
//       _____________________________________________________         ________
// DATA:                                                      |_______|
//          _    _    _    _    _    _    _    _    _        ___     ___
// SCK : __| |__| |__| |__| |__| |__| |__| |__| |__| |______|   |___|   |______
{  
  char i;
  printf("\r\nResetting the connection to the sensor..");
  TO_SENSOR; 
  DATA=1; 
  SCK=0;                    //Initial state
  for(i=0;i<9;i++)                  //9 SCK cycles
  { SCK=1;
    delay_ms(1);
    SCK=0;
    delay_ms(1);
  }
  sht_xmit_start();                   //transmission start
}

//----------------------------------------------------------------------------------
char sht_softreset(void)
//----------------------------------------------------------------------------------
// resets the sensor by a softreset 
{ 
  error=0;  
  sht_connectionreset();              //reset communication
  error+=sht_write_byte(SENSORRESET);       //send RESET-command to sensor
  return error;                     //error=1 in case of no response form the sensor
}

//----------------------------------------------------------------------------------
char sht_read_statusreg(char *p_value, char *p_checksum)
//----------------------------------------------------------------------------------
// reads the status register with checksum (8-bit)
{ 
  error=0;
  sht_xmit_start();                   //transmission start
  error=sht_write_byte(STATUS_REG_R); //send command to sensor
  *p_value=sht_read_byte(ACK);        //read status register (8-bit)
  *p_checksum=sht_read_byte(noACK);   //read checksum (8-bit)  
  return error;                     //error=1 in case of no response form the sensor
}

//----------------------------------------------------------------------------------
char sht_write_statusreg(char *p_value)
//----------------------------------------------------------------------------------
// writes the status register with checksum (8-bit)
{ 
  error=0;
  sht_xmit_start();                   //transmission start
  error+=sht_write_byte(STATUS_REG_W);//send command to sensor
  error+=sht_write_byte(*p_value);    //send value of status register
  return error;                     //error>=1 in case of no response form the sensor
}
 unsigned int reading;
 char hi_byte,lo_byte;							   
//----------------------------------------------------------------------------------
char sht_measure(unsigned int *p_value, char *p_checksum, char mode)
//----------------------------------------------------------------------------------
// makes a sht_measurement (humidity/temperature) with checksum
{ 
  unsigned int i;
  char timer;
  error=0;

  sht_xmit_start();                   
  switch(mode){                     	//send command to sensor
    case TEMP:
	    printf("\r\nMeasuring Temperature.."); 
		error+=sht_write_byte(MEASURE_TEMP); 
	break;
    case HUMI: 
	    printf("\r\nMeasuring Humidity.."); 
		error+=sht_write_byte(MEASURE_HUMI); 
	break;
    default     : break;	 
  }
   timer = secs;						//wait for measurement complete
   timer +=2; 
   do{
    ++i;
   }while(DATA_IN == 1 && secs < timer);

  if(DATA_IN) 
   error+=1;                			// or timeout (~2 sec.) is reached
  hi_byte = sht_read_byte(ACK);    		//read the first byte (MSB)
  lo_byte = sht_read_byte(ACK);    		//read the second byte (LSB)
  *p_checksum =sht_read_byte(noACK);  	//read checksum
  *p_value = make16(hi_byte,lo_byte);	//store reading
  return error;
}
void main(void)
{
	unsigned int i,temp,evstat_data;
	char rc,timer;
	ADCON1 = 0x0F;	//PORTA all digital	
	SETUP_A;
//******************************************************************
//*	CONFIGURE EEPROM READ/WRITE
//******************************************************************
	EECON1 = 0b00000000;
//******************************************************************
//*	CONFIGURE AND START TIMER1
//* SET TO OVERFLOW EVERY 1S
//******************************************************************
	TMR1ON = 0;
	TMR1H = 0x80;
	TMR1L = 0x00;
	T1CON = 0b00001110;
	TMR1IE = 1;
	hours = 12;
	mins = 0x00;
	secs = 0x00;
	TMR1ON = 1;
	
	init_USART1();
	menu();
	enter_parms();
	init_cf_card();
    //enable_GLOBALint;	//enable_interrupts(GLOBAL);
	airdrop_cfg(BSS);
	airdrop_cfg(SSID);
	airdrop_cfg(MAX_DATALEN);
	airdrop_cfg(NIC_RATE);
	//airdrop_cfg(WEP_KEY_128);
	//airdrop_cfg(WEP_KEYID);
    //airdrop_cfg(WEP_AUTH_SK);
	airdrop_cfg(WEP_OFF);
	temp = rid_read(RID_cfgOwnMACAddress);
	for(i=0;i<6;i++)
    {
		if(i%2)
			macaddrc[i] = fidrid_buffer[2+i/2]>>8;
		else
			macaddrc[i] = fidrid_buffer[2+i/2]& 0xFF;
    }
	for(i=0;i<3;++i)
     macaddri[i] = fidrid_buffer[i+2];
	ipaddri[0] = make16(ipaddrc[1],ipaddrc[0]);
	ipaddri[1] = make16(ipaddrc[3],ipaddrc[2]);

	remoteipaddri[0] = make16(remoteipaddrc[1],remoteipaddrc[0]);
	remoteipaddri[1] = make16(remoteipaddrc[3],remoteipaddrc[2]);

	allocate_xmit_buffers();
	wr_cf_io16(0xFFFF, EvAck_Register);
	if(rc=send_command(EnableMAC_Cmd,0))
	 printf("MAC Enable Error\r\n");
	do{
	    temp=rid_read(RID_PortStatus);
	   }while(fidrid_buffer[2]!=4);
	temp = rid_read(RID_CurrentBSSID);
	for(i=0;i<6;i++)
	{
		if(i%2)
			bssidc[i] = fidrid_buffer[2+i/2]>>8;
		else
			bssidc[i] = fidrid_buffer[2+i/2]& 0xFF;
    }
	for(i=0;i<3;++i)
	 bssidi[i] = fidrid_buffer[i+2];

     //temp = rid_read(RID_CommsQuality);
	printf("\r\nDiscovering HOST Hardware Address..");
	clr_arpflag;
	do{
   		rc = arp_request();
		do{
			evstat_data = rd_cf_io16(EvStat_Register);
	  	  }while(!(evstat_data & EvStat_Rx_Bit_Mask));
		get_frame();
	   }while(barpflag == 0);
	printf("\r\nHOST Hardware Address = %02X-%02X-%02X-%02X-%02X-%02X",remotemacaddrc[0],remotemacaddrc[1],remotemacaddrc[2],remotemacaddrc[3],remotemacaddrc[4],remotemacaddrc[5]);
	delay_ms(100);
	init_udp();

   while(1){
	if(mins == parameters[loopsecs])
	 {
	  send_udp_discard();	//discard udp port
	  delay_ms(100);
	  send_udp();	
	  mins = 0x00;
	 }
	do{
		evstat_data = rd_cf_io16(EvStat_Register);
	  }while(!(evstat_data & EvStat_Rx_Bit_Mask));
	get_frame();
    }
}

